/* connect.c */

#include <windows.h>
#include "connect.h"
#include "message.h"
#include "fce.h"
#include "keycode.h"

#define MAX_STR   64

extern HCURSOR ArrowCursor;      /* arrow cursor */
extern HCURSOR WaitCursor;       /* hour glass cursor */
extern int ConnectStatus;

void Message(LPSTR);
void ShowError(int,LPSTR);
int IsConnected(void);

static HWND SavedDlg = 0;
static char SrvrString[MAX_STR] = ""; /* FTP server name */
static char UserString[MAX_STR] = ""; /* user login name */
static char PassString[MAX_STR] = ""; /* user login password */

///EnableWindow(GetDlgItem(hDlg,ID_STOP_BTN), EnableFlag);

#ifdef WIN32
BOOL CALLBACK
#else
BOOL FAR PASCAL
#endif
ConnectDlgProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{int Code;
 static char Temp[100];

 switch (iMsg)
    {case WM_INITDIALOG:
        SavedDlg = hDlg;
#if 1
        SetDlgItemText(hDlg, ID_SRVR_BOX, (LPSTR)"ftp.marshallsoft.com");
        SetDlgItemText(hDlg, ID_USER_BOX, (LPSTR)"anonymous");
        SetDlgItemText(hDlg, ID_PASS_BOX, (LPSTR)"msc@traveller.com");
#else
        SetDlgItemText(hDlg, ID_SRVR_BOX, (LPSTR)"10.0.0.1");
        SetDlgItemText(hDlg, ID_USER_BOX, (LPSTR)"mike");
        SetDlgItemText(hDlg, ID_PASS_BOX, (LPSTR)"mike");
#endif
        SetCursor(ArrowCursor);
        EnableWindow(GetDlgItem(hDlg,ID_CONN_BTN), 1);
        return TRUE;

      case WM_COMMAND :
        switch (LOWORD(wParam))
         {
          case ID_CONN_BTN:
            GetDlgItemText(hDlg, ID_SRVR_BOX, (LPSTR)SrvrString, MAX_STR);
            GetDlgItemText(hDlg, ID_USER_BOX, (LPSTR)UserString, MAX_STR);
            GetDlgItemText(hDlg, ID_PASS_BOX, (LPSTR)PassString, MAX_STR);
            SetCursor(WaitCursor);
            /* define LOG file */
            fceSetString(0,FCE_SET_LOG_FILE,(LPSTR)"winftp.log");
            EnableWindow(GetDlgItem(hDlg,ID_CONN_BTN), 0);
            /* connect to server */
            Code = fceConnect(0,(LPSTR)SrvrString,(LPSTR)UserString,(LPSTR)PassString);
            if(Code<0)
              {ConnectStatus = FALSE;
               ShowError(Code,NULL);
              }
            else
              {ConnectStatus = TRUE;
               wsprintf((LPSTR)Temp,"Connected to %s",(LPSTR)SrvrString);
               Message((LPSTR)Temp);
              }
#if 0
             /* set some time limits */
             fceSetInteger(0, FCE_SET_DATA_WAIT, 1500);
             fceSetInteger(0, FCE_SET_MIN_LINE_WAIT, 250);
             fceSetInteger(0, FCE_SET_MIN_RESPONSE_WAIT, 250);
#endif
             EndDialog(hDlg, 0);
             return TRUE;
          case ID_EXIT_BTN:
             EndDialog(hDlg, 0);
             return TRUE;
         }
         break;
    }
    return (FALSE);
} /* end ConnectDlgProc */

