//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "dial_pgm.h"
#include "mdd.h"
#include "keycode.h"

// globals

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TDial *Dial;
//---------------------------------------------------------------------------
__fastcall TDial::TDial(TComponent* Owner)
    : TForm(Owner)
{int Code;
 int Version;
 int Build;
 int NbrEntries;
 char Buffer[128];
 char Temp[128];
 printf("MarshallSoft DUN Dialer (MDD) Example\n");
 Code = mddAttach(MDD_KEY_CODE);
 if(Code<0)
   {wsprintf((LPSTR)Temp,"ERROR %d: Cannot attach MDD. Check your key code.\n", Code);
    memoInfo->SetTextBuf(Temp);
    return;
   }
 /* display build, version, and registration */
 Version = mddDebug(MDD_GET_VERSION,(LPSTR)Buffer,65);
 Build = mddDebug(MDD_GET_BUILD,(LPSTR)Buffer,65);
 wsprintf((LPSTR)Temp,"MDD32 Version: %1d.%1d.%1d Build %d\r\n",
   0x0f&(Version>>8),0x0f&(Version>>4),0x0f&Version,Build);
 memoInfo->SetTextBuf(Temp);
 mddDebug(MDD_GET_REGISTRATION,(LPSTR)Buffer,65);
 wsprintf((LPSTR)Temp,"Registration: %s\r\n", Buffer);
 memoInfo->Lines->Append(Temp);
 /* load all dial entries */
 Code = mddLoadEntries();
 wsprintf((LPSTR)Temp,"%d available entries.", Code);
 memoInfo->Lines->Append(Temp);
 if(Code>0)
   {/* list all dialing entries */
    NbrEntries = Code;
    if(NbrEntries>=1)
      {/* check 1st entry */
       Code = mddGetEntry(0, (LPSTR)Buffer, 128);
       if(Code>0)
         {btnEntry1->Caption = Buffer;
          btnEntry1->Visible = TRUE;
         }
       }
    if(NbrEntries>=2)
      {/* check 2nd entry */
       Code = mddGetEntry(1, (LPSTR)Buffer, 128);
       if(Code>0)
         {btnEntry2->Caption = Buffer;
          btnEntry2->Visible = TRUE;
         }
      }
    if(NbrEntries>=3)
      {/* check 3rd entry */
       Code = mddGetEntry(2, (LPSTR)Buffer, 128);
       if(Code>0)
         {btnEntry3->Caption = Buffer;
          btnEntry3->Visible = TRUE;
         }
       }
    if(NbrEntries>=4)
      {/* check 4th entry */
       Code = mddGetEntry(3, (LPSTR)Buffer, 128);
       if(Code>0)
         {btnEntry4->Caption = Buffer;
          btnEntry4->Visible = TRUE;
         }
       }
     if(NbrEntries>=5)
      {/* check 5th entry */
       Code = mddGetEntry(4, (LPSTR)Buffer, 128);
       if(Code>0)
         {btnEntry5->Caption = Buffer;
          btnEntry5->Visible = TRUE;
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnExitClick(TObject *Sender)
{// exit
 btnExit->Enabled = FALSE;
 Timer1->Enabled = FALSE;
 btnEntry1->Enabled = FALSE;
 btnEntry2->Enabled = FALSE;
 btnEntry3->Enabled = FALSE;
 btnEntry4->Enabled = FALSE;
 btnEntry5->Enabled = FALSE;
 memoInfo->Lines->Append("Hanging up...");
 mddHangup();
 Sleep(1500);
 memoInfo->Lines->Append("Releasing MDD...");
 mddRelease();
 Sleep(500);
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnEntry1Click(TObject *Sender)
{char Temp[128];
 btnEntry1->Enabled = FALSE;
 btnExit->Enabled = FALSE;
 wsprintf((LPSTR)Temp,"Dialing using first entry");
 memoInfo->Lines->Append(Temp);
 mddBeginDial(0);
 Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnEntry2Click(TObject *Sender)
{char Temp[128];
 btnEntry2->Enabled = FALSE;
 btnExit->Enabled = FALSE;
 wsprintf((LPSTR)Temp,"Dialing using second entry");
 memoInfo->Lines->Append(Temp);
 mddBeginDial(1);
 Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnEntry3Click(TObject *Sender)
{char Temp[128];
 btnEntry3->Enabled = FALSE;
 btnExit->Enabled = FALSE;
 wsprintf((LPSTR)Temp,"Dialing using third entry");
 memoInfo->Lines->Append(Temp);
 mddBeginDial(2);
 Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnEntry4Click(TObject *Sender)
{char Temp[128];
 btnEntry4->Enabled = FALSE;
 btnExit->Enabled = FALSE;
 wsprintf((LPSTR)Temp,"Dialing using fourth entry");
 memoInfo->Lines->Append(Temp);
 mddBeginDial(3);
 Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TDial::btnEntry5Click(TObject *Sender)
{char Temp[128];
 btnEntry4->Enabled = FALSE;
 btnExit->Enabled = FALSE;
 wsprintf((LPSTR)Temp,"Dialing using fifth entry");
 memoInfo->Lines->Append(Temp);
 mddBeginDial(4);
 Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TDial::Timer1Timer(TObject *Sender)
{int Code;
 int Status;
 static int LastStatus = 0;
 char Temp[128];
 char Buffer[128];
 /* get dialing status */
 Status = mddDialStatus();
 if(Status!=LastStatus)
   {LastStatus = Status;
    /* display status */
    Code = mddStatusText(Status,(LPSTR)Buffer, 128);
    if(Code>0)
      {wsprintf((LPSTR)Temp,"Status %4d: %s", Status, Buffer);
       memoInfo->Lines->Append(Temp);
      }
    if( (LastStatus==MDD_IS_CONNECTED)    ||
        (LastStatus==MDD_IS_DISCONNECTED) ||
        (LastStatus==MDD_IS_AUTHENICATED)
      )
        {Timer1->Enabled = FALSE;
         btnExit->Enabled = TRUE;
         memoInfo->Lines->Append("Action completed.");
        }
   }
}
//---------------------------------------------------------------------------