*
* FIELDS.PRG
*
*   Visual FoxPro "Fields" program. Lists all files by field.
*
* PROGRAMMER:
*   (1) Edit the variables 'FTPserver', 'FTPuser', 'FTPpass' below.
*   (2) Edit the INCLUDE commands with the location of FCE32CON.FOX and KEYCODE.FOX.

#INCLUDE FCE32CON.FOX
#INCLUDE KEYCODE.FOX

DECLARE INTEGER fceAbort in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceAttach in FCE32.DLL INTEGER Chan,  LONG KeyCode
DECLARE INTEGER fceClose in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceCommand in FCE32.DLL INTEGER Chan, STRING @Buffer
DECLARE INTEGER fceConnect in FCE32.DLL INTEGER Chan, STRING @Server, STRING @User, STRING @Pass
DECLARE INTEGER fceDebug in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceDelFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceDelServerDir in FCE32.DLL INTEGER Chan,  STRING @ServerName
DECLARE INTEGER fceDriver in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceErrorText in FCE32.DLL INTEGER Chan, INTEGER Code, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceExtract in FCE32.DLL STRING @Buffer, INTEGER LineNbr, INTEGER FieldNbr, STRING @Buffer, INTEGER
DECLARE INTEGER fceGetFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceGetInteger in FCE32.DLL INTEGER Chan, INTEGER Index
DECLARE INTEGER fceGetList in FCE32.DLL INTEGER Chan, INTEGER, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetLocalDir in FCE32.DLL INTEGER Chan, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetServerDir in FCE32.DLL INTEGER Chan, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetString in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceHello in FCE32.DLL INTEGER
DECLARE INTEGER fceMakeServerDir in FCE32.DLL INTEGER Chan,  STRING @DirName
DECLARE INTEGER fcePutFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceRelease in FCE32.DLL
DECLARE INTEGER fceSetInteger in FCE32.DLL INTEGER Chan, INTEGER ParmIndex, INTEGER ParmValue
DECLARE INTEGER fceSetLocalDir in FCE32.DLL INTEGER Chan, STRING @DirName
DECLARE INTEGER fceSetMode in FCE32.DLL INTEGER Chan, INTEGER Mode
DECLARE INTEGER fceSetServerDir in FCE32.DLL INTEGER Chan, STRING @DirName
DECLARE INTEGER fceSetString in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Text

#define TEMP_SIZE 128
#define DATA_SIZE 5000

? "FIELDS 5/24/2000"

FTPserver = "10.0.0.1"
FTPuser = "mike"
FTPpass = "mike"

* attach FCE
Code = fceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE (check key code) ", Code
  return
endif
* connect to FTP server
? "Connecting to ", FTPserver
Code = fceConnect(0, @FTPserver, @FTPuser, @FTPpass)
if Code < 0
  DisplayError(Code)
  Code = fceRelease()
  return
endif
? "Connected. Now getting file fields."
* list files on server
DataBuffer = SPACE(DATA_SIZE)
Code = fceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
if Code <= 0
  DisplayError(Code)
else
  ? Left(DataBuffer,Code)
  * list each field in each line
  NbrLines = fceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
  For Line = 1 To NbrLines
    ? "*** Line ", Line, " ***"
    For FieldPos = 1 To 12
      LineBuf = SPACE(128)
      Code = fceExtract(@DataBuffer, Line, FieldPos, @LineBuf, 128)
      If Code > 0
        ? "FIELD ", LTRIM(STR(FieldPos)), ": ", LineBuf
      EndIf
    EndFor
  EndFor
endif
* log off
Code = fceClose(0)
Code = fceRelease()
? "Logged off."
return

Procedure DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = fceErrorText(0,ErrCode,@TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return
