*
* FIELDS.PRG
*
* Xbase++ "FieldPoss" program.
*
* PROGRAMMER:
*   (1) Edit the variables 'FTPserver', 'FTPuser', 'FTPpass' below.
*   (2) Edit the INCLUDE commands with the location of FCE32.CH and KEYCODE.CH.
*   (3) Copy FCE32.CH to the xBase++ INCLUDE directory.
*   (4) To compile: xpp fields.prg
*   (5) To link: alink /subsystem:console fields.obj fce32.lib

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "FCE32.CH"

#define TEMP_SIZE 128
#define DATA_SIZE 5000

Procedure Main()

? "FIELDS 5/18/2000"

FTPserver = "10.0.0.1"
FTPuser = "mike"
FTPpass = "mike"

* attach FCE
Code = XfceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE (check key code) ", Code
  return
endif
* connect to FTP server
? "Connecting to ", FTPserver
Code = XfceConnect(0, FTPserver, FTPuser, FTPpass)
if Code < 0
  DisplayError(Code)
  Code = XfceRelease()
  return
endif
? "Connected. Now getting file fields."
* list files on server
DataBuffer = SPACE(DATA_SIZE)
Code = XfceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
if Code <= 0
  DisplayError(Code)
else
  ? Left(DataBuffer,Code)
  * list each field in each line
  NbrLines = XfceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
  For Line = 1 To NbrLines
    ? "*** Line ", Line, " ***"
    For FieldPos = 1 To 12
      LineBuf = SPACE(100)
      Code = XfceExtract(@DataBuffer, Line, FieldPos, @LineBuf, 100)
      If Code > 0
        ? "FIELD ", LTRIM(STR(FieldPos)), ": ", LineBuf
      EndIf
    EndFor
  EndFor
endif
* log off
Code = XfceClose(0)
Code = XfceRelease()
? "Logged off."
return

Procedure DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceErrorText(0,ErrCode,@TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return
