*
* FTP.PRG
*
* Xbase++ "FTP" program.
*
* PROGRAMMER:
*   (1) Edit the variables 'FTPserver', 'FTPuser', 'FTPpass' below.
*   (2) Edit the INCLUDE commands with the location of FCE32.CC and KEYCODE.CC.
*   (3) Copy FCE32.CC to the xBase++ INCLUDE directory.
*   (4) To compile: xpp ftp.prg
*   (5) To link: alink /subsystem:console ftp.obj fce32.lib
*

***#INCLUDE "COMMON.CH"
***#INCLUDE "XBP.CH"

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "FCE32.CH"

#define TEMP_SIZE 128
#define DATA_SIZE 5000

Procedure Main()

***FTPserver = "ftp.marshallsoft.com"
***FTPuser = "anonymous"
***FTPpass = "msc@traveller.com"

FTPserver = "10.0.0.1"
FTPuser = "mike"
FTPpass = "mike"

LocalDir = ""
DiagFile = "FTP.LOG"

? "FTP 5/18/2000"

PassiveMode = 0
XferMode = ASC("A")

Code = XfceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE (check key code) ", Code
  return
endif
Code = XfceSetString(0, FCE_SET_LOG_FILE, @DiagFile)
? "Connecting to server " + FTPserver
Code = XfceConnect(0, @FTPserver, @FTPuser, @FTPpass)
if Code < 0
  DisplayError(Code)
  Code = XfceRelease()
  return
endif
* get server IP address
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceGetString(0, FCE_GET_SERVER_IP, @TempBuffer, TEMP_SIZE)
if Code > 0
  ? "Connected to ", Left(TempBuffer, Code)
endif
* set local directory
Code = XfceSetLocalDir(0, @LocalDir)
PassiveMode = 0
ShowHelp()
* process each command from user
do while .T.
  ?
  ?? ">"
  Command = Upper(Chr(InKey(0)))
  ?? Command
  do case
    *** ignore carriage return
    case Command == chr(13)
    *** Help
    case Command == "H"
      ShowHelp()
    *** Toggle PASSIVE mode
    case Command == "P"
      if PassiveMode == 0
        PassiveMode = 1
        Code = XfceSetInteger(0, FCE_SET_PASSIVE, 1)
        ShowResult(Code, "Passive mode set to ON")
      else
        PassiveMode = 0
        Code = XfceSetInteger(0, FCE_SET_PASSIVE, 0)
        ShowResult(Code, "Passive mode set to OFF")
      endif
    *** ASCII mode
    case Command == "A"
      XferMode = ASC("A")
      Code = XfceSetMode(0, XferMode)
      ShowResult(Code, "ASCII mode set.")
    *** Binary mode
    case Command == "B"
      XferMode = ASC("B")
      Code = XfceSetMode(0, XferMode)
      ShowResult(Code, "Binary mode set.")
    *** List files
    case Command == "L"
      ShowXferMode(XferMode)
      DataBuffer = SPACE(DATA_SIZE)
      Code = XfceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? Left(DataBuffer,Code)
        Code = XfceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
        ? Code, " lines."
      endif
    *** Change server directory
    case Command == "C"
      ? "Enter FULL server directory name: "
      DirName = AcceptString()
      if ASC(DirName) <> 0
        ? "Setting server directory to ", DirName
        Code = XfceSetServerDir(0, @DirName)
        if Code <= 0
          DisplayError(Code)
        else
          ? "Type S to see server directory name."
        endif
      endif
    *** Show server directory
    case Command == "S"
      DirName = SPACE(TEMP_SIZE)
      Code = XfceGetServerDir(0, @DirName, TEMP_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? "Server directory is ", DirName
      endif
    *** Download file
    case Command == "D"
      ShowXferMode(XferMode)
      ? "Enter filename to download: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        ? "Please wait while file is being downloaded..."
        Code = XfceGetFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          ? FileName," downloaded."
        endif
      endif
    *** Upload file [requires server permission!]
    case Command == "U"
      ShowXferMode(XferMode)
      ? "Enter filename to upload: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        ? "Please wait while file is being uploaded..."
        Code = XfcePutFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          ? FileName," uploaded."
        endif
      endif
    *** Quit
    case Command == "Q"
       Code = XfceClose(0)
       Code = XfceRelease()
       return
  otherwise
    ? "Cannot recognize command "
  endcase
enddo
return

Function AcceptString()
Sval = ""
DO While .T.
  X = InKey(0)
  ?? Chr(X)
  If (X > ASC(" ")) .And. (X <= ASC("~"))
    Sval = Sval + Chr(X)
  else
    exit
  endif
Enddo
Sval = Sval + Chr(0) + Chr(0)
return Sval

Procedure ShowHelp()
? "H -- Help"
? "A -- Set ASCII transfer mode"
? "B -- Set binary transfer mode"
? "C -- Change (server) working directory"
? "D -- Download file"
? "L -- List all files"
? "P -- Toggle PASSIVE mode"
? "Q -- Quit"
? "S -- Show (server) working directory"
? "U -- Upload file"
return

Procedure DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceErrorText(0,ErrCode,@TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return

Procedure ShowResult(RetCode,Message)
if RetCode >= 0
  ? Message
else
  DisplayError(RetCode)
endif
return

Procedure ShowXferMode(Mode)
if Mode = ASC("A")
  ? "Xfer mode is ASCII"
endif
if Mode = ASC("B")
  ? "Xfer mode is binary"
endif
return



