*
* FTP2.PRG
*
*   Visual FoxPro "FTP" program (for FCE 2.0). Generic FTP client.
*   Uses fceDriver. Compare to FTP.PRG.
*
* PROGRAMMER:
*   (1) Edit the variables 'FTPserver', 'FTPuser', 'FTPpass' below.
*   (2) Edit the INCLUDE commands with the location of FCE32CON.FOX and KEYCODE.FOX.
*

#INCLUDE FCE32CON.FOX
#INCLUDE KEYCODE.FOX

DECLARE INTEGER fceAbort in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceAttach in FCE32.DLL INTEGER Chan,  LONG KeyCode
DECLARE INTEGER fceClose in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceCommand in FCE32.DLL INTEGER Chan, STRING @Buffer
DECLARE INTEGER fceConnect in FCE32.DLL INTEGER Chan, STRING @Server, STRING @User, STRING @Pass
DECLARE INTEGER fceDebug in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceDelFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceDelServerDir in FCE32.DLL INTEGER Chan,  STRING @ServerName
DECLARE INTEGER fceDriver in FCE32.DLL INTEGER Chan
DECLARE INTEGER fceErrorText in FCE32.DLL INTEGER Chan, INTEGER Code, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceExtract in FCE32.DLL STRING @Buffer, INTEGER LineNbr, INTEGER FieldNbr, STRING @Buffer, INTEGER
DECLARE INTEGER fceGetFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceGetInteger in FCE32.DLL INTEGER Chan, INTEGER Index
DECLARE INTEGER fceGetList in FCE32.DLL INTEGER Chan, INTEGER, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetLocalDir in FCE32.DLL INTEGER Chan, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetServerDir in FCE32.DLL INTEGER Chan, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceGetString in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER fceHello in FCE32.DLL INTEGER
DECLARE INTEGER fceMakeServerDir in FCE32.DLL INTEGER Chan,  STRING @DirName
DECLARE INTEGER fcePutFile in FCE32.DLL INTEGER Chan, STRING @FileName
DECLARE INTEGER fceRelease in FCE32.DLL
DECLARE INTEGER fceSetInteger in FCE32.DLL INTEGER Chan, INTEGER ParmIndex, INTEGER ParmValue
DECLARE INTEGER fceSetLocalDir in FCE32.DLL INTEGER Chan, STRING @DirName
DECLARE INTEGER fceSetMode in FCE32.DLL INTEGER Chan, INTEGER Mode
DECLARE INTEGER fceSetServerDir in FCE32.DLL INTEGER Chan, STRING @DirName
DECLARE INTEGER fceSetString in FCE32.DLL INTEGER Chan, INTEGER Index, STRING @Text

**FTPserver = "ftp.marshallsoft.com"
**FTPuser = "anonymous"
**FTPpass = "msc@traveller.com"

FTPserver = "10.0.0.1"
FTPuser = "mike"
FTPpass = "mike"

LocalDir = "C:\TEMP"
DiagFile = "C:\TEMP\FTP.LOG"

*******************************

#define TEMP_SIZE 128
#define DATA_SIZE 5000

? "FTP2 5/24/2000"

PassiveMode = 0
XferMode = ASC("A")

Code = fceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE (check key code) ", Code
  return
endif
Code = fceSetString(0, FCE_SET_LOG_FILE, @DiagFile)
* connect to FTP server
? "Connecting to " + FTPserver
Code = fceConnect(0, @FTPserver, @FTPuser, @FTPpass)
if Code < 0
  DisplayError(Code)
  Code = fceRelease()
  return
endif
TempBuffer = SPACE(TEMP_SIZE)
Code = fceGetString(0, FCE_GET_SERVER_IP, @TempBuffer, TEMP_SIZE)
if Code > 0
  ? "Connected to ", Left(TempBuffer, Code)
endif
* set local directory
Code = fceSetLocalDir(0, @LocalDir)
if Code < 0
  ? "Cannot set local directory"
  return
endif
PassiveMode = 0
ShowHelp()
* process each command from user
do while Code >= 0
  ?
  ?? ">"
  Command = Upper(Chr(InKey(0)))
  ?? Command
  do case
    *** ignore carriage return
    case Command == chr(13)
    *** Help
    case Command == "H"
      ShowHelp()
    *** Toggle PASSIVE mode
    case Command == "P"
      if PassiveMode == 0
        PassiveMode = 1
        Code = fceSetInteger(0, FCE_SET_PASSIVE, 1)
        ShowResult(Code, "Passive mode set to ON")
      else
        PassiveMode = 0
        Code = fceSetInteger(0, FCE_SET_PASSIVE, 0)
        ShowResult(Code, "Passive mode set to OFF")
      endif
    *** ASCII mode
    case Command == "A"
      XferMode = ASC("A")
      Code = fceSetMode(0, XferMode)
      ShowResult(Code, "ASCII mode set.")
    *** Binary mode
    case Command == "B"
      XferMode = ASC("B")
      Code = fceSetMode(0, XferMode)
      ShowResult(Code, "Binary mode set.")
    *** List files
    case Command == "L"
      ShowXferMode(XferMode)
      DataBuffer = SPACE(DATA_SIZE)
      Code = fceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? Left(DataBuffer,Code)
        Code = fceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
        ? Code, " lines."
      endif
    *** Change server directory
    case Command == "C"
      ? "Enter FULL server directory name: "
      DirName = AcceptString()
      if ASC(DirName) <> 0
        ? "Setting server directory to ", DirName
        Code = fceSetServerDir(0, @DirName)
        if Code <= 0
          DisplayError(Code)
        else
          ? "Type S to see server directory name."
        endif
      endif
    *** Show server directory
    case Command == "S"
      DirName = SPACE(TEMP_SIZE)
      Code = fceGetServerDir(0, @DirName, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? "Server directory is ", DirName
      endif
    *** Download file
    case Command == "D"
      ShowXferMode(XferMode)
      ? "Enter filename to download: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        * turn AUTO CALL off
        Code = fceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
        Code = fceGetFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          * run the driver
          if RunTheDriver() == 0
            ? FileName," downloaded."
          endif
        endif
        * turn AUTO CALL back on
        Code = fceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
      endif
    *** Upload file [requires server permission!]
    case Command == "U"
      ShowXferMode(XferMode)
      ? "Enter filename to upload: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        * turn AUTO CALL off
        Code = fceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
        Code = fcePutFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          * run the driver
          if RunTheDriver() == 0
            ? FileName," uploaded."
          endif
        endif
        * turn AUTO CALL back on
        Code = fceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
      endif
    *** Quit
    case Command == "Q"
       Code = fceClose(0)
       Code = fceRelease()
       return
  otherwise
    ? "Cannot recognize command "
  endcase
enddo
return

Function AcceptString()
Sval = ""
DO While .T.
  X = InKey(0)
  ?? Chr(X)
  If (X > ASC(" ")) And (X <= ASC("~"))
    Sval = Sval + Chr(X)
  else
    exit
  endif
Enddo
Sval = Sval + Chr(0) + Chr(0)
return Sval

Function ShowHelp()
? "H -- Help"
? "A -- Set ASCII transfer mode"
? "B -- Set binary transfer mode"
? "C -- Change (server) working directory"
? "D -- Download file"
? "L -- List all files"
? "P -- Toggle PASSIVE mode"
? "Q -- Quit"
? "S -- Show (server) working directory"
? "U -- Upload file"
return

Function DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = fceErrorText(0,ErrCode,@TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return

Function ShowResult(RetCode,Message)
if RetCode >= 0
  ? Message
else
  DisplayError(RetCode)
endif
return

Function ShowXferMode(Mode)
if Mode = ASC("A")
  ? "Xfer mode is ASCII"
endif
if Mode = ASC("B")
  ? "Xfer mode is binary"
endif
return

Function RunTheDriver
* run the driver
Counter = 0
LastCount = 0
ThisCount = 0
Code = 1
do while Code > 0
  Code = fceDriver(0)
  if Code < 0
    * error returned
    DisplayError(Code)
    return Code
  endif
  Counter = Counter + 1
  * check bytes transferred every 20'th call
  if ( (Counter == 20) .or. (Code == 0) )
    ThisCount = fceGetInteger(0, FCE_GET_FILE_BYTES_SENT) + fceGetInteger(0, FCE_GET_FILE_BYTES_RCVD)
    if ThisCount != LastCount
      ? ThisCount, " bytes."
      LastCount = ThisCount
    endif
    Counter = 0
  endif
enddo
return Code
