*
* FTP2.PRG
*
* Xbase++ "FTP" program. Uses fceDriver. Compare to FTP.PRG.
*
* PROGRAMMER:
*   (1) Edit the variables 'FTPserver', 'FTPuser', 'FTPpass' below.
*   (2) Edit the INCLUDE commands with the location of FCE32.CH and KEYCODE.CH.
*   (3) Copy FCE32.CH to the xBase++ INCLUDE directory.
*   (4) To compile: xpp ftp2.prg
*   (5) To link: alink /subsystem:console ftp2.obj fce32.lib
*

***#INCLUDE "COMMON.CH"
***#INCLUDE "XBP.CH"

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "FCE32.CH"

Procedure Main()

***FTPserver = "ftp.marshallsoft.com"
***FTPuser = "anonymous"
***FTPpass = "msc@traveller.com"

FTPserver = "10.0.0.1"
FTPuser = "mike"
FTPpass = "mike"

LocalDir = ""
DiagFile = "FTP2.LOG"

*******************************

#define TEMP_SIZE 128
#define DATA_SIZE 5000

? "FTP2 5/18/2000"

PassiveMode = 0
XferMode = ASC("A")

* attach FCE
Code = XfceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE (check key code) ", Code
  return
endif
Code = XfceSetString(0, FCE_SET_LOG_FILE, @DiagFile)
? "Connecting to server " + FTPserver
Code = XfceConnect(0, @FTPserver, @FTPuser, @FTPpass)
if Code < 0
  DisplayError(Code)
  Code = XfceRelease()
  return
endif
* get server IP address
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceGetString(0, FCE_GET_SERVER_IP, @TempBuffer, TEMP_SIZE)
if Code > 0
  ? "Connected to ", Left(TempBuffer, Code)
endif
? "Setting local directory."
Code = XfceSetLocalDir(0, @LocalDir)
PassiveMode = 0
ShowHelp()
* process each command from user
do while .T.
  ?
  ?? ">"
  Command = Upper(Chr(InKey(0)))
  ?? Command
  do case
    *** ignore carriage return
    case Command == chr(13)
    *** Help
    case Command == "H"
      ShowHelp()
    *** Toggle PASSIVE mode
    case Command == "P"
      if PassiveMode == 0
        PassiveMode = 1
        Code = XfceSetInteger(0, FCE_SET_PASSIVE, 1)
        ShowResult(Code, "Passive mode set to ON")
      else
        PassiveMode = 0
        Code = XfceSetInteger(0, FCE_SET_PASSIVE, 0)
        ShowResult(Code, "Passive mode set to OFF")
      endif
    *** ASCII mode
    case Command == "A"
      XferMode = ASC("A")
      Code = XfceSetMode(0, XferMode)
      ShowResult(Code, "ASCII mode set.")
    *** Binary mode
    case Command == "B"
      XferMode = ASC("B")
      Code = XfceSetMode(0, XferMode)
      ShowResult(Code, "Binary mode set.")
    *** List files
    case Command == "L"
      ShowXferMode(XferMode)
      DataBuffer = SPACE(DATA_SIZE)
      Code = XfceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? Left(DataBuffer,Code)
        Code = XfceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
        ? Code, " lines."
      endif
    *** Change server directory
    case Command == "C"
      ? "Enter FULL server directory name: "
      DirName = AcceptString()
      if ASC(DirName) <> 0
        ? "Setting server directory to ", DirName
        Code = XfceSetServerDir(0, @DirName)
        if Code <= 0
          DisplayError(Code)
        else
          ? "Type S to see server directory name."
        endif
      endif
    *** Show server directory
    case Command == "S"
      DirName = SPACE(TEMP_SIZE)
      Code = XfceGetServerDir(0, @DirName, TEMP_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? "Server directory is ", DirName
      endif
    *** Download file
    case Command == "D"
      ShowXferMode(XferMode)
      ? "Enter filename to download: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        * turn AUTO CALL off
        Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
        Code = XfceGetFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          * run the driver
          if RunTheDriver() == 0
            ? FileName," downloaded."
          endif
        endif
        * turn AUTO CALL back on
        Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
      endif
    *** Upload file [requires server permission!]
    case Command == "U"
      ShowXferMode(XferMode)
      ? "Enter filename to upload: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        * turn AUTO CALL off
        Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
        Code = XfcePutFile(0, @FileName)
        if Code < 0
          DisplayError(Code)
        else
          * run the driver
          if RunTheDriver() == 0
            ? FileName," uploaded."
          endif
        endif
        * turn AUTO CALL back on
        Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
      endif
    *** Quit
    case Command == "Q"
       Code = XfceClose(0)
       Code = XfceRelease()
       return
  otherwise
    ? "Cannot recognize command "
  endcase
enddo
return

Function AcceptString()
Sval = ""
do while .T.
  X = InKey(0)
  ?? Chr(X)
  If (X > ASC(" ")) && (X <= ASC("~"))
    Sval = Sval + Chr(X)
  else
    exit
  endif
Enddo
Sval = Sval + Chr(0) + Chr(0)
return Sval

Procedure ShowHelp()
? "H -- Help"
? "A -- Set ASCII transfer mode"
? "B -- Set binary transfer mode"
? "C -- Change (server) working directory"
? "D -- Download file"
? "L -- List all files"
? "P -- Toggle PASSIVE mode"
? "Q -- Quit"
? "S -- Show (server) working directory"
? "U -- Upload file"
return

Procedure DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceErrorText(0,ErrCode,@TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return

Procedure ShowResult(RetCode,Message)
if RetCode >= 0
  ? Message
else
  DisplayError(RetCode)
endif
return

Function RunTheDriver
* run the driver
Counter = 0
LastCount = 0
ThisCount = 0
Code = 1
do while Code > 0
  Code = XfceDriver(0)
  if Code < 0
    // error returned
    DisplayError(Code)
    return Code
  endif
  Counter = Counter + 1
  * check bytes transferred every 20'th call
  if ( (Counter == 20) .or. (Code == 0) )
    ThisCount = XfceGetInteger(0, FCE_GET_FILE_BYTES_SENT) + XfceGetInteger(0, FCE_GET_FILE_BYTES_RCVD)
    if ThisCount != LastCount
      ? ThisCount, " bytes."
      LastCount = ThisCount
    endif
    Counter = 0
  endif
enddo
return Code

Procedure ShowXferMode(Mode)
if Mode = ASC("A")
  ? "Xfer mode is ASCII"
endif
if Mode = ASC("B")
  ? "Xfer mode is binary"
endif
return
