*
* FTP32.PRG [for 32-bit dBase 7.X]
*
* Visual dBase "FTP" program (for FCE 2.1). Compare to WINFTP.WFM.
*
*
* PROGRAMMER:
*   Set the variables 'FTPserver', 'FTPuser', 'FTPpass' before compiling.
*   Also edit the following INCLUDE commands with the location of
*   FCE32.CC and KEYCODE.CC.

#INCLUDE C:\TEMP\FCE32.CC
#INCLUDE C:\TEMP\KEYCODE.CC

FTPserver = "ftp.marshallsoft.com" + Chr(0)
FTPuser = "anonymous" + Chr(0)
FTPpass = "msc@traveller.com" + Chr(0)

LocalDir = "C:\TEMP"
DiagFile = "C:\TEMP\FTP.LOG"

*******************************

#define TEMP_SIZE 128
#define DATA_SIZE 5000

? "FTP 5/8/2000"

PassiveMode = 0
XferMode = ASC("A")

Code = fceAttach(1, FCE_KEY_CODE)
if Code < 0
  ? "Cannot attach FCE ", Code
  return
endif
Code = fceSetString(0, FCE_SET_LOG_FILE, DiagFile)
* connect to FTP server
? "Connecting to " + FTPserver
Code = fceConnect(0, FTPserver, FTPuser, FTPpass)
if Code < 0
  DisplayError(Code)
  Code = fceRelease()
  return
endif
TempBuffer = SPACE(TEMP_SIZE)
Code = fceGetString(0, FCE_GET_SERVER_IP, TempBuffer, TEMP_SIZE)
if Code > 0
  ? "Connected to ", Left(TempBuffer, Code)
endif
* set local directory
Code = fceSetLocalDir(0, LocalDir)
PassiveMode = 0
ShowHelp()
* process each command from user
do while true
  ?
  ?? ">"
  Command = Upper(Chr(InKey(0)))
  ?? Command
  do case
    *** ignore carriage return
    case Command == chr(13)
    *** Help
    case Command == "H"
      ShowHelp()
    *** Toggle PASSIVE mode
    case Command == "P"
      if PassiveMode == 0
        PassiveMode = 1
        Code = fceSetInteger(0, FCE_SET_PASSIVE, 1)
        ShowResult(Code, "Passive mode set to ON")
      else
        PassiveMode = 0
        Code = fceSetInteger(0, FCE_SET_PASSIVE, 0)
        ShowResult(Code, "Passive mode set to OFF")
      endif
    *** ASCII mode
    case Command == "A"
      XferMode = ASC("A")
      Code = fceSetMode(0, XferMode)
      ShowResult(Code, "ASCII mode set.")
    *** Binary mode
    case Command == "B"
      XferMode = ASC("B")
      Code = fceSetMode(0, XferMode)
      ShowResult(Code, "Binary mode set.")
    *** List files
    case Command == "L"
      ShowXferMode(XferMode)
      DataBuffer = SPACE(DATA_SIZE)
      Code = fceGetList(0, FCE_FULL_LIST, DataBuffer, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? Left(DataBuffer,Code)
      endif
    *** Change server directory
    case Command == "C"
      ? "Enter FULL server directory name: "
      DirName = AcceptString()
      if ASC(DirName) <> 0
        ? "Setting server directory to ", DirName
        Code = fceSetServerDir(0, DirName)
        if Code <= 0
          DisplayError(Code)
        else
          ? "Type S to see server directory name."
        endif
      endif
    *** Show server directory
    case Command == "S"
      DirName = SPACE(TEMP_SIZE)
      Code = fceGetServerDir(0, DirName, DATA_SIZE)
      if Code <= 0
        DisplayError(Code)
      else
        ? "Server directory is ", DirName
      endif
    *** Download file
    case Command == "D"
      ShowXferMode(XferMode)
      ? "Enter filename to download: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        ? "You must wait while download is in progress."
        Wait
        Code = fceGetFile(0, FileName)
        if Code < 0
          DisplayError(Code)
        else
          ? FileName," downloaded."
        endif
      endif
    *** Upload file [requires server permission!]
    case Command == "U"
      ShowXferMode(XferMode)
      ? "Enter filename to upload: "
      FileName = AcceptString()
      if Asc(FileName) <> 0
        ? "You must wait while upload is in progress."
        Wait
        Code = fcePutFile(0, FileName)
        if Code < 0
          DisplayError(Code)
        else
          ? FileName, " uploaded."
        endif
      endif
    *** Quit
    case Command == "Q"
       Code = fceClose(0)
       Code = fceRelease()
       return
  otherwise
    ? "Cannot recognize command "
  endcase
enddo
return

Function AcceptString()
Sval = ""
DO While true
  X = InKey(0)
  ?? Chr(X)
  If (X > ASC(" ")) And (X <= ASC("~"))
    Sval = Sval + Chr(X)
  else
    exit
  endif
Enddo
Sval = Sval + Chr(0) + Chr(0)
return Sval

Function ShowHelp()
? "H -- Help"
? "A -- Set ASCII transfer mode"
? "B -- Set binary transfer mode"
? "C -- Change (server) working directory"
? "D -- Download file"
? "L -- List all files"
? "P -- Toggle PASSIVE mode"
? "Q -- Quit"
? "S -- Show (server) working directory"
? "U -- Upload file"
return

Function DisplayError(ErrCode)
TempBuffer = SPACE(TEMP_SIZE)
Code = fceErrorText(0,ErrCode,TempBuffer,TEMP_SIZE)
? Left(TempBuffer,Code)
return

Function ShowResult(RetCode,Message)
if RetCode >= 0
  ? Message
else
  DisplayError(RetCode)
endif
return

Function ShowXferMode(Mode)
if Mode = ASC("A")
  ? "Xfer mode is ASCII"
endif
if Mode = ASC("B")
  ? "Xfer mode is binary"
endif
return

