000010 @OPTIONS NOALPHA
000020 @OPTIONS MAIN
000030 *>
000040 *>
000050 *>  Source Module: GETRAW.CBL
000060 *>
000070 *>  Last Modified: February 28, 2000.
000080 *>
000090 *>  Author:  MDM
000100 *>
000110 *>  Must be linked with SEE32.LIB
000120 *>
000130 *>  IMPORTANT:  Edit POP3-SERVER, POP3-USER, and POP3-PASS
000140 *>    with appropriate strings before compiling.
000150 *>    See the SEE User's Manual (SEE_USR).
000160 *>
000170
000180 IDENTIFICATION DIVISION.
000190 PROGRAM-ID.    GETRAW.
000200 AUTHOR.        Mike Marshall.
000210 INSTALLATION.  Fujitsu COBOL.
000220
000230 ENVIRONMENT DIVISION.
000240 CONFIGURATION SECTION.
000250 SOURCE-COMPUTER. Fujitsu.
000260 OBJECT-COMPUTER. Fujitsu.
000270 SPECIAL-NAMES.
000280 COPY "SEE32.CBI".
000290 INPUT-OUTPUT SECTION.
000300 FILE-CONTROL.
000310     SELECT FILE-NAME
000320     ASSIGN TO "FILE.RAW"
000330     ORGANIZATION IS SEQUENTIAL
000340     ACCESS MODE IS SEQUENTIAL
000350     PADDING CHARACTER IS " "
000360     FILE STATUS IS FILE-STATUS.
000370
000380 DATA DIVISION.
000390
000400 FILE SECTION.
000410 FD FILE-NAME RECORD CONTAINS 1 CHARACTERS.
000420 01 FILE-DATA.
000430    05 FILLER PIC X(1).
000440
000450 WORKING-STORAGE SECTION.
000460  77  FILE-STATUS PIC 99.
000470 COPY "KEYCODE.CBI".
000480  01  SEE-CODE     PIC S9(9) COMP-5 VALUE 0.
000490  01  CHARS-READ   PIC S9(9) COMP-5 VALUE 0.
000500  01  IS-ZERO      PIC 9(9)  COMP-5 VALUE 0.
000510  01  MESSAGE-NBR  PIC 9(9)  COMP-5 VALUE 1.
000520  01  BUFFER       PIC X(1000000).
000530  01  BUF-LEN      PIC 9(9)  COMP-5 VALUE 1000000.
000540  01  TEMP-BUF     PIC X(128).
000550  01  TEMP-LEN     PIC 9(9)  COMP-5 VALUE 128.
000560  01  NBR-CHANS    PIC S9(9) COMP-5 VALUE 1.
000570  01  NBR-LINES    PIC S9(9) COMP-5 VALUE 0.
000580  01  CHANNEL      PIC S9(9) COMP-5 VALUE 0.
000590  01  POP3-SERVER.
000600      05  FILLER PIC X(8) VALUE "10.0.0.1".
000610      05  FILLER PIC X VALUE X'00'.
000620  01  POP3-USER.
000630      05  FILLER PIC X(4) VALUE "mike".
000640      05  FILLER PIC X VALUE X'00'.
000650  01  POP3-PASS.
000660      05  FILLER PIC X(4) VALUE "mike".
000670      05  FILLER PIC X VALUE X'00'.
000680  01  NBR-MESSAGES PIC S9(9) COMP-5 VALUE 0.
000690  01  RESULT.
000700      05  FILLER PIC X(55).
000710      05  FILLER PIC X VALUE X'00'.
000720  01  RESULT-LEN PIC S9(9) COMP-5 VALUE 55.
000730  01  COUNTER PIC 9(9) COMP-5 VALUE 0.
000740
000750 PROCEDURE DIVISION.
000760
000770      DISPLAY "GETRAW.CBL Program"
000780      DISPLAY " "
000790
000800      DISPLAY "Server is " POP3-SERVER
000810      DISPLAY "User is " POP3-USER
000820      DISPLAY " "
000830
000840      *> attach SEE
000850      CALL "seeAttach" WITH STDCALL USING
000860           BY VALUE     NBR-CHANS     *> number of channels
000870           BY VALUE     SEE_KEY_CODE  *> See KEYCODE.CBI
000880      END-CALL.
000890
000900      *> connect to POP3 server
000910      DISPLAY "Calling seePop3Connect()..."
000920      CALL "seePop3Connect" WITH STDCALL USING
000930           BY VALUE     CHANNEL       *> channel
000940           BY REFERENCE POP3-SERVER   *> POP3 server name
000950           BY REFERENCE POP3-USER     *> user name
000960           BY REFERENCE POP3-PASS     *> user password
000970      END-CALL.
000980
000990      *> check result
001000      IF PROGRAM-STATUS < 0 THEN
001010        DISPLAY "Cannot connect to POP3 server"
001020        MOVE PROGRAM-STATUS TO SEE-CODE
001030        GO TO DISPLAY-ERROR
001040      END-IF.
001050
001060      *> get # messages waiting
001070      DISPLAY "Calling seeGetEmailCount()..."
001080      CALL "seeGetEmailCount" WITH STDCALL USING
001090           BY VALUE     CHANNEL       *> channel
001100      END-CALL.
001110
001120      *> check result
001130      IF PROGRAM-STATUS < 0 THEN
001140        DISPLAY "Error getting email count"
001150        MOVE PROGRAM-STATUS TO SEE-CODE
001160        GO TO DISPLAY-ERROR
001170      END-IF.
001180
001190      MOVE PROGRAM-STATUS TO NBR-MESSAGES
001200      DISPLAY NBR-MESSAGES " messages waiting on server."
001210
001220      *> has user typed key ?
001230      DISPLAY "Enter message number to download: " WITH NO ADVANCING
001240      ACCEPT MESSAGE-NBR
001250
001260      IF MESSAGE-NBR > NBR-MESSAGES THEN
001270        DISPLAY "There is no message " MESSAGE-NBR
001280        GO TO CLOSE-SEE
001290      END-IF.
001300
001310      DISPLAY "Downloading message " MESSAGE-NBR
001320
001330      *> read email message
001340      DISPLAY "Calling seeGetEmailLines()..."
001350
001360      CALL "seeGetEmailLines" WITH STDCALL USING
001370         BY VALUE     CHANNEL       *> channel
001380         BY VALUE     MESSAGE-NBR   *> message number (1,2,...)
001390         BY VALUE     NBR-LINES     *> email filename
001400         BY REFERENCE BUFFER        *> resultant buffer
001410         BY VALUE     BUF-LEN       *> buffer length
001420      END-CALL
001430
001440      *> check result
001450      IF PROGRAM-STATUS < 0 THEN
001460        DISPLAY "Cannot download email"
001470        MOVE PROGRAM-STATUS TO SEE-CODE
001480        GO TO DISPLAY-ERROR
001490      END-IF.
001500
001510      *> prepare to save to disk
001520      MOVE PROGRAM-STATUS TO CHARS-READ
001530      DISPLAY "Saving " CHARS-READ " characters to FILE.RAW"
001540      OPEN OUTPUT FILE-NAME
001550      DISPLAY "OPEN returns " FILE-STATUS
001560      MOVE 1 TO COUNTER.
001570
001580 WRITE-LOOP.
001590
001600      *> write next character to disk
001610      MOVE BUFFER(COUNTER:COUNTER) TO FILE-DATA
001620      WRITE FILE-DATA
001630      END-WRITE
001640      IF COUNTER = CHARS-READ THEN
001650        CLOSE FILE-NAME
001660        GO TO CLOSE-SEE
001670      END-IF
001680      ADD 1 TO COUNTER
001690      GO TO WRITE-LOOP.
001700
001710 CLOSE-SEE.
001720
001730      *> close SEE
001740      DISPLAY "Calling seeClose()..."
001750      CALL "seeClose" WITH STDCALL USING
001760         BY VALUE     CHANNEL       *> channel
001770      END-CALL
001780      GO TO RELEASE-SEE.
001790
001800 DISPLAY-ERROR.
001810
001820      DISPLAY "SEE4CB Error " SEE-CODE
001830      MOVE SPACES TO TEMP-BUF
001840      CALL "seeErrorText" WITH STDCALL USING
001850         BY VALUE     CHANNEL       *> channel
001860         BY VALUE     SEE-CODE
001870         BY REFERENCE TEMP-BUF
001880         BY VALUE     TEMP-LEN
001890      END-CALL
001900      DISPLAY TEMP-BUF.
001910
001920 RELEASE-SEE.
001930
001940      *> release SEE
001950      DISPLAY "Calling seeRelease()..."
001960      CALL "seeRelease" WITH STDCALL
001970      END-CALL
001980
001990      DISPLAY "All done."
002000      STOP RUN.
002010
002020 END PROGRAM GETRAW.
002030
002040
