000010 @OPTIONS NOALPHA
000020 @OPTIONS MAIN
000030
000040 *>
000050 *>
000060 *>  Source Module: MAILER2.CBL
000070 *>
000080 *>  Last Modified: February 28, 2000.
000090 *>
000100 *>  Author:  MDM
000110 *>
000120 *>  Must be linked with SEE32.LIB
000130 *>
000140 *> IMPORTANT:  Edit SMTP-SERVER, EMAIL-TO, EMAIL-FROM, EMAIL-SUBJ,
000150 *>    EMAIL-MSG, and EMAIL-ATTACH with appropriate strings before.
000160 *>    compiling. See the SEE User's manual (SEE_USR).
000170 *>
000180
000190 IDENTIFICATION DIVISION.
000200 PROGRAM-ID.    MAILER2.
000210 AUTHOR.        Mike Marshall.
000220 INSTALLATION.  Fujitsu COBOL.
000230
000240 ENVIRONMENT DIVISION.
000250 CONFIGURATION SECTION.
000260 SOURCE-COMPUTER. Fujitsu.
000270 OBJECT-COMPUTER. Fujitsu.
000280 SPECIAL-NAMES.
000290
000300 COPY "SEE32.CBI".
000310
000320 DATA DIVISION.
000330 WORKING-STORAGE SECTION.
000340 COPY "KEYCODE.CBI".
000350  01  NBR-CHANS    PIC S9(9) COMP-5 VALUE 1.
000360  01  AUTO-CALL    PIC 9(9) COMP-5 VALUE SEE_AUTO_CALL_DRIVER.
000370  01  IS-ZERO      PIC 9(9) COMP-5 VALUE 0.
000380  01  IS-ONE       PIC 9(9) COMP-5 VALUE 1.
000390  01  BUFFER       PIC X(80).
000400  01  BUF-LEN      PIC 9(9) COMP-5 VALUE 80.
000410  01  SEE-CODE     PIC S9(9) COMP-5 VALUE 0.
000420  01  CHANNEL      PIC S9(9) COMP-5 VALUE 0.
000430  01  BYTES-SENT   PIC S9(9) COMP-5 VALUE 0.
000440  01  SMTP-SERVER.
000450      05  FILLER PIC X(8) VALUE "10.0.0.1".
000460      05  FILLER PIC X VALUE X'00'.
000470  01  EMAIL-TO.
000480      05  FILLER PIC X(15) VALUE "<mike@10.0.0.1>".
000490      05  FILLER PIC X VALUE X'00'.
000500  01  EMAIL-FROM.
000510      05  FILLER PIC X(15) VALUE "<mike@10.0.0.1>".
000520      05  FILLER PIC X VALUE X'00'.
000530  01  EMAIL-SUBJ.
000540      05  FILLER PIC X(18) VALUE "Attaching TEST.ZIP".
000550      05  FILLER PIC X VALUE X'00'.
000560  01  EMAIL-MSG.
000570      05  FILLER PIC X(9) VALUE "@test.mai".
000580      05  FILLER PIC X VALUE X'00'.
000590  01  EMAIL-ATTACH.
000600      05  FILLER PIC X(8) VALUE "test.zip".
000610      05  FILLER PIC X VALUE X'00'.
000620  01  RESULT.
000630      05  FILLER PIC X(40).
000640      05  FILLER PIC X VALUE X'00'.
000650  01  COUNTER    PIC 9(9) COMP-5 VALUE 0.
000660
000670 PROCEDURE DIVISION.
000680
000690      DISPLAY "MAILER2.CBL Program"
000700      DISPLAY " "
000710
000720      DISPLAY "Server is " SMTP-SERVER
000730      DISPLAY "Email To "  EMAIL-TO
000740      DISPLAY "Email From "  EMAIL-FROM
000750      DISPLAY "Email Subject "  EMAIL-SUBJ
000760      DISPLAY " "
000770
000780      *> attach SEE
000790      CALL "seeAttach" WITH STDCALL USING
000800           BY VALUE     NBR-CHANS     *> number of channels
000810           BY VALUE     SEE_KEY_CODE  *> See KEYCODE.CBI
000820      END-CALL.
000830
000840      *> connect to SMTP server
000850      DISPLAY "Calling seeSmptConnect()..."
000860      CALL "seeSmtpConnect" WITH STDCALL USING
000870           BY VALUE     CHANNEL       *> channel
000880           BY REFERENCE SMTP-SERVER   *> SMTP server name
000890           BY REFERENCE EMAIL-FROM    *> sender's email address
000900           BY REFERENCE EMAIL-ATTACH  *> no Reply-To header
000910      END-CALL.
000920
000930      *> check result
000940      IF PROGRAM-STATUS < 0 THEN
000950        DISPLAY "Cannot connect to SMTP server"
000960        MOVE PROGRAM-STATUS TO SEE-CODE
000970        GO TO ERROR-EXIT
000980      END-IF.
000990
001000      *> turn OFF automatic calls to driver for seeSendEmail
001010      CALL "seeIntegerParam" WITH STDCALL USING
001020           BY VALUE     CHANNEL       *> channel
001030           BY VALUE     AUTO-CALL     *> Command
001040           BY VALUE     IS-ZERO       *> off
001050      END-CALL.
001060
001070      *> set up to send email
001080      DISPLAY "Calling seeSendEmail()..."
001090      CALL "seeSendEmail" WITH STDCALL USING
001100           BY VALUE     CHANNEL       *> channel
001110           BY REFERENCE EMAIL-TO      *> receipient
001120           BY REFERENCE IS-ZERO       *> no CC list
001130           BY REFERENCE IS-ZERO       *> no BCC list
001140           BY REFERENCE EMAIL-SUBJ    *> email subject
001150           BY REFERENCE EMAIL-MSG     *> text of message
001160           BY REFERENCE EMAIL-ATTACH  *> attachment
001170      END-CALL.
001180
001190      *> check result of call to seeSendEmail
001200      IF PROGRAM-STATUS < 0 THEN
001210        DISPLAY "Cannot send email"
001220        MOVE PROGRAM-STATUS TO SEE-CODE
001230        GO TO ERROR-EXIT
001240      END-IF.
001250
001260      *> call driver
001270
001280  MAILER2-LOOP.
001290
001300      CALL "seeDriver" WITH STDCALL USING
001310        BY VALUE     CHANNEL       *> channel
001320      END-CALL.
001330
001340      *> check results
001350      MOVE PROGRAM-STATUS TO SEE-CODE
001360      IF SEE-CODE < 0 THEN
001370        DISPLAY "Error returned from seeDriver"
001380        GO TO ERROR-EXIT
001390      END-IF.
001400
001410      IF SEE-CODE >= 0 THEN
001420        *> don't count wait states (9999)
001430        IF SEE-CODE NOT EQUAL 9999 THEN
001440          *> check every 10th call
001450          ADD 1 TO COUNTER
001460          IF (COUNTER = 10) OR (SEE-CODE = 0) THEN
001470            *> ask for bytes sent
001480            CALL "seeStatistics" WITH STDCALL USING
001490              BY VALUE     CHANNEL
001500              BY VALUE     SEE_GET_TOTAL_BYTES_SENT
001510            END-CALL
001520            *> display bytes sent if changed
001530            IF PROGRAM-STATUS NOT = BYTES-SENT THEN
001540              MOVE PROGRAM-STATUS TO BYTES-SENT
001550              DISPLAY BYTES-SENT " bytes sent."
001560            END-IF
001570            MOVE IS-ZERO TO COUNTER
001580          END-IF
001590        END-IF
001600        IF SEE-CODE > 0 THEN
001610          GO TO MAILER2-LOOP
001620        END-IF
001630      END-IF.
001640
001650      *> SEE-CODE was 0
001660      DISPLAY "Email sent."
001670
001680      *> turn ON automatic calls to driver
001690      CALL "seeIntegerParam" WITH STDCALL USING
001700           BY VALUE     CHANNEL       *> channel
001710           BY VALUE     AUTO-CALL     *> Command
001720           BY VALUE     IS-ONE        *> off
001730      END-CALL.
001740
001750      *> close SEE
001760      DISPLAY "Calling seeClose()..."
001770      CALL "seeClose" WITH STDCALL USING
001780         BY VALUE     CHANNEL       *> channel
001790      END-CALL
001800
001810      *> release SEE
001820      CALL "seeRelease" WITH STDCALL
001830      END-CALL
001840
001850      DISPLAY "All done."
001860      STOP RUN.
001870
001880  ERROR-EXIT.
001890
001900      DISPLAY "SEE4CB Error " SEE-CODE
001910      CALL "seeErrorText" WITH STDCALL USING
001920         BY VALUE     CHANNEL       *> channel
001930         BY VALUE     SEE-CODE
001940         BY REFERENCE BUFFER
001950         BY VALUE     BUF-LEN
001960      END-CALL
001970      DISPLAY BUFFER
001980      STOP RUN.
001990
002000 END PROGRAM MAILER2.
002010
002020
