/*
** MDD.H2
**
** For Win32 compilers supporting the "declspec" keyword.
**
*/

#ifdef STATIC_LIBRARY
    #define DLL_IMPORT_EXPORT
#else
    #ifdef DLL_SOURCE_CODE
       #define DLL_IMPORT_EXPORT __declspec(dllexport) __stdcall
    #else
       #define DLL_IMPORT_EXPORT __declspec(dllimport) __stdcall
    #endif
#endif

#ifdef __cplusplus
  #define NoMangle extern "C"
#else
  #define NoMangle
#endif

#define MDD_IS_CONNECTED       8192
#define MDD_IS_DISCONNECTED    8193
#define MDD_IS_AUTHENTICATED     14

#define MDD_GET_VERSION           1
#define MDD_GET_BUILD             2
#define MDD_GET_REGISTRATION      3

#define MDD_NO_ERROR              1
#define MDD_EOF                  -1
#define MDD_ABORTED              -2
#define MDD_ALREADY_ATTACHED     -3
#define MDD_NO_SUCH_ENTRY        -4

#define MDD_BAD_KEY_CODE        -74

#define BYTE  unsigned char
#define WORD  unsigned int
#define ULONG unsigned long

NoMangle int  DLL_IMPORT_EXPORT mddAttach(long);
NoMangle int  DLL_IMPORT_EXPORT mddBeginDial(unsigned);
NoMangle int  DLL_IMPORT_EXPORT mddDebug(int, LPSTR, unsigned);
NoMangle int  DLL_IMPORT_EXPORT mddDialStatus(void);
NoMangle int  DLL_IMPORT_EXPORT mddErrorText(int, LPSTR, unsigned);
NoMangle int  DLL_IMPORT_EXPORT mddGetEntry(unsigned, LPSTR, unsigned);
NoMangle int  DLL_IMPORT_EXPORT mddLoadEntries(void);
NoMangle int  DLL_IMPORT_EXPORT mddRelease(void);
NoMangle int  DLL_IMPORT_EXPORT mddStatusText(int, LPSTR, unsigned);
NoMangle void DLL_IMPORT_EXPORT mddHangup(void);
