*
* READER.PRG
*
* Alaska Xbase++ "READER" program (for SEE 3.0 and above)
*
* This program logs onto POP3 server 'Pop3Server' and downloads
* message number 'MsgNbr' into directory 'EmailDir' as a file named
* 'EmailName'. Any attachment is downloaded into directory 'AttachDir'.
*
*
* PROGRAMMER:
*   (1) To compile: XPP READER.PRG
*   (2) To link: ALINK READER.OBJ SEE32.LIB
*

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "SEE32.CH"

Procedure Main()

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\reader.log"
* Note 1: do NOT use pathname in EmailName
EmailName = "email.txt"
* Note 2: use full path names unless file is located in Xbase++ directory
EmailDir = "C:\TEMP"
AttachDir = "C:\TEMP"
*** END PROGRAMMER ***

? "READER 02/21/2000"
Code = XseeAttach(1, SEE_KEY_CODE)
if Code < 0
  ? "Cannot attach SEE"
  return
endif
Code = XseeStringParam(0,SEE_LOG_FILE, @DiagFile)
* set maximum connect wait to 10 seconds
Code = XseeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
* connect to POP3 server
? "Connecting to " + Pop3Server
Code = XseePop3Connect(0, @Pop3Server, @Pop3UserName, @Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = XseeErrorText(0, Code, @Temp, 128)
  ? Left(Temp,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMessages = XseeGetEmailCount(0)
  if NbrMessages < 0
    Temp = SPACE(128)
    Code = XseeErrorText(0, NbrMessages, @Temp, 128)
    ? Left(Temp,Code)
  else
    ? NbrMessages," messages waiting."
    If NbrMessages = 0
      Code = XseeClose(0)
      Code = XseeRelease()
      return
    Endif
    ? "Enter message # to read (and delete):"
    MsgNbr = AcceptInteger()
    If ((MsgNbr>0) .AND. (MsgNbr <= NbrMessages))
      ? "Reading Message ", LTRIM(STR(MsgNbr)), ", please wait..."
      Code = XseeGetEmailFile(0, MsgNbr, @EmailName, @EmailDir, @AttachDir)
      if Code < 0
        Temp = SPACE(128)
        Code = XseeErrorText(0, Code, @Temp, 128)
        ? Left(Temp,Code)
        Code = XseeClose(0)
        Code = XseeRelease()
        return
      endif
      ? "Saved as ", LTRIM(EmailName)
      * deleting message from server
      Code = XseeDeleteEmail(0, MsgNbr)
      ? "Message ",  LTRIM(STR(MsgNbr)), " deleted from server."
    else
      ? "No such message"
    endif
  endif
endif
? "Done."
Code = XseeClose(0)
Code = XseeRelease()
return

Function AcceptInteger()
Private Value
Private X
Value = 0
DO While Value >= 0
  X = InKey(0)
  ?? Chr(X)
  If (X >= Asc("0")) .AND. (X <= Asc("9"))
    Value = 10 * Value + (X - Asc("0"))
  else
    exit
  endif
Enddo
return Value
