000010 @OPTIONS NOALPHA
000020 @OPTIONS MAIN
000030
000040 *>
000050 *>
000060 *>  Source Module: READER2.CBL
000070 *>
000080 *>  Last Modified: February 28, 2000.
000090 *>
000100 *>  Author:  MDM
000110 *>
000120 *>  Must be linked with SEE32.LIB
000130 *>
000140 *> IMPORTANT:  Edit POP3-SERVER, POP3-USER, and POP3-PASS
000150 *>    with appropriate strings before compiling.
000160 *>    See the SEE User's Manual (SEE_USR).
000170 *>
000180
000190 IDENTIFICATION DIVISION.
000200 PROGRAM-ID.    READER2.
000210 AUTHOR.        Mike Marshall.
000220 INSTALLATION.  Fujitsu COBOL.
000230
000240 ENVIRONMENT DIVISION.
000250 CONFIGURATION SECTION.
000260 SOURCE-COMPUTER. Fujitsu.
000270 OBJECT-COMPUTER. Fujitsu.
000280 SPECIAL-NAMES.
000290
000300 COPY "SEE32.CBI".
000310
000320 DATA DIVISION.
000330
000340 WORKING-STORAGE SECTION.
000350
000360 COPY "KEYCODE.CBI".
000370  01  SEE-CODE     PIC S9(9) COMP-5 VALUE 0.
000380  01  IS-ZERO      PIC 9(9)  COMP-5 VALUE 0.
000390  01  IS-ONE       PIC 9(9)  COMP-5 VALUE 1.
000400  01  BUFFER       PIC X(80).
000410  01  BUF-LEN      PIC 9(9)  COMP-5 VALUE 80.
000420  01  NBR-CHANS    PIC S9(9) COMP-5 VALUE 1.
000430  01  CHANNEL      PIC S9(9) COMP-5 VALUE 0.
000440  01  POP3-SERVER.
000450      05  FILLER PIC X(8) VALUE "10.0.0.1".
000460      05  FILLER PIC X VALUE X'00'.
000470  01  POP3-USER.
000480      05  FILLER PIC X(4) VALUE "mike".
000490      05  FILLER PIC X VALUE X'00'.
000500  01  POP3-PASS.
000510      05  FILLER PIC X(4) VALUE "mike".
000520      05  FILLER PIC X VALUE X'00'.
000530  01  CHAR-SET.
000540      02  CHARS PIC X(35) VALUE "123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".
000550      02  FILLER REDEFINES CHARS.
000560          03 WORK PIC X OCCURS 35 TIMES.
000570  01  EMAIL-NAME.
000580      02  FILLER PIC X(6) VALUE "EMAIL-".
000590      02  SECOND PIC X(1) VALUE "A".
000600      02  FILLER PIC X(4) VALUE ".MAI".
000610      02  FILLER PIC X VALUE X'00'.
000620  01  EMAIL-DIR.
000630      05  FILLER PIC X(6) VALUE ".\".
000640      05  FILLER PIC X    VALUE X'00'.
000650  01  ATTACH-DIR.
000660      05  FILLER PIC X(6) VALUE ".\".
000670      05  FILLER PIC X    VALUE X'00'.
000680  01  NUMBER-MESSAGES PIC S9(9) COMP-5 VALUE 0.
000690  01  COUNTER PIC S9(9) COMP-5 VALUE 1.
000700  01  MESSAGE-COUNT PIC S9(9) COMP-5 VALUE 0.
000710  01  RESULT.
000720      05  FILLER PIC X(55).
000730      05  FILLER PIC X VALUE X'00'.
000740  01  RESULT-LEN PIC S9(9) COMP-5 VALUE 55.
000750  01  BYTES-READ PIC S9(9) COMP-5 VALUE 0.
000760  01  AUTO-CALL  PIC 9(9) COMP-5 VALUE SEE_AUTO_CALL_DRIVER.
000770
000780 PROCEDURE DIVISION.
000790
000800      DISPLAY "READER2.CBL Program"
000810      DISPLAY " "
000820
000830      DISPLAY "Server is " POP3-SERVER
000840      DISPLAY "User is " POP3-USER
000850      DISPLAY " "
000860
000870      *> attach SEE
000880      CALL "seeAttach" WITH STDCALL USING
000890           BY VALUE     NBR-CHANS     *> number of channels
000900           BY VALUE     SEE_KEY_CODE  *> See KEYCODE.CBI
000910      END-CALL.
000920
000930      *> connect to POP3 server
000940      DISPLAY "Calling seePop3Connect()..."
000950      CALL "seePop3Connect" WITH STDCALL USING
000960           BY VALUE     CHANNEL       *> channel
000970           BY REFERENCE POP3-SERVER   *> POP3 server name
000980           BY REFERENCE POP3-USER     *> user name
000990           BY REFERENCE POP3-PASS     *> user password
001000      END-CALL.
001010
001020      *> check result
001030      IF PROGRAM-STATUS < 0 THEN
001040        DISPLAY "Cannot connect to POP3 server"
001050        MOVE PROGRAM-STATUS TO SEE-CODE
001060        GO TO ERROR-EXIT
001070      END-IF.
001080
001090      *> get # messages waiting
001100      DISPLAY "Calling seeGetEmailCount()..."
001110      CALL "seeGetEmailCount" WITH STDCALL USING
001120           BY VALUE     CHANNEL       *> channel
001130      END-CALL.
001140
001150      *> check result
001160      IF PROGRAM-STATUS < 0 THEN
001170        DISPLAY "Error getting email count"
001180        MOVE PROGRAM-STATUS TO SEE-CODE
001190        GO TO ERROR-EXIT
001200      END-IF.
001210
001220      MOVE PROGRAM-STATUS TO NUMBER-MESSAGES
001230      DISPLAY NUMBER-MESSAGES " messages waiting on server."
001240
001250      MOVE 1 TO MESSAGE-COUNT.
001260
001270  PROCESS-LOOP.
001280
001290      *> any more email messages ?
001300      IF MESSAGE-COUNT > NUMBER-MESSAGES THEN
001310        GO TO PROCESS-DONE
001320      END-IF.
001330
001340      *> turn OFF automatic calls to driver for seeSendEmail
001350      CALL "seeIntegerParam" WITH STDCALL USING
001360           BY VALUE     CHANNEL       *> channel
001370           BY VALUE     AUTO-CALL     *> Command
001380           BY VALUE     IS-ZERO       *> off
001390      END-CALL.
001400
001410      *> construct email message name
001420      MOVE WORK(MESSAGE-COUNT) TO SECOND
001430
001440      *> read email message
001450      DISPLAY "Calling seeGetEmailFile()..."
001460      CALL "seeGetEmailFile" WITH STDCALL USING
001470         BY VALUE     CHANNEL         *> channel
001480         BY VALUE     MESSAGE-COUNT   *> message number (1,2,...)
001490         BY REFERENCE EMAIL-NAME      *> email filename
001500         BY REFERENCE EMAIL-DIR       *> email directory
001510         BY REFERENCE ATTACH-DIR      *> attachment directory
001520      END-CALL
001530      DISPLAY "Saving message" MESSAGE-COUNT " as " EMAIL-NAME.
001540
001550      *> call driver
001560
001570  READER2-LOOP.
001580
001590      CALL "seeDriver" WITH STDCALL USING
001600        BY VALUE     CHANNEL       *> channel
001610      END-CALL.
001620
001630      *> check results
001640      MOVE PROGRAM-STATUS TO SEE-CODE
001650      IF SEE-CODE < 0 THEN
001660        DISPLAY "Error returned from seeDriver"
001670        GO TO ERROR-EXIT
001680      END-IF.
001690
001700      IF SEE-CODE >= 0 THEN
001710        *> don't count wait states (9999)
001720        IF SEE-CODE NOT EQUAL 9999 THEN
001730          *> check every 10th call
001740          ADD 1 TO COUNTER
001750          IF (COUNTER = 10) OR (SEE-CODE = 0) THEN
001760            *> ask for bytes read
001770            CALL "seeStatistics" WITH STDCALL USING
001780              BY VALUE     CHANNEL
001790              BY VALUE     SEE_GET_TOTAL_BYTES_READ
001800            END-CALL
001810            *> display bytes read if changed
001820            IF PROGRAM-STATUS NOT = BYTES-READ THEN
001830              MOVE PROGRAM-STATUS TO BYTES-READ
001840              DISPLAY BYTES-READ " bytes read."
001850            END-IF
001860            MOVE IS-ZERO TO COUNTER
001870          END-IF
001880        END-IF
001890        IF SEE-CODE > 0 THEN
001900          GO TO READER2-LOOP
001910        END-IF
001920      END-IF.
001930
001940      *> SEE-CODE was 0
001950      DISPLAY "Email read."
001960
001970      *> turn ON automatic calls to driver
001980      CALL "seeIntegerParam" WITH STDCALL USING
001990           BY VALUE     CHANNEL       *> channel
002000           BY VALUE     AUTO-CALL     *> Command
002010           BY VALUE     IS-ONE        *> off
002020      END-CALL.
002030
002040      ADD 1 TO MESSAGE-COUNT
002050      GO TO PROCESS-LOOP.
002060
002070  PROCESS-DONE.
002080
002090      *> close SEE
002100      DISPLAY "Calling seeClose()..."
002110      CALL "seeClose" WITH STDCALL USING
002120         BY VALUE     CHANNEL       *> channel
002130      END-CALL
002140
002150      *> release SEE
002160      DISPLAY "Calling seeRelease()..."
002170      CALL "seeRelease" WITH STDCALL
002180      END-CALL
002190
002200      DISPLAY "All done."
002210      STOP RUN.
002220
002230  ERROR-EXIT.
002240
002250      DISPLAY "SEE4CB Error " SEE-CODE
002260      CALL "seeErrorText" WITH STDCALL USING
002270         BY VALUE     CHANNEL       *> channel
002280         BY VALUE     SEE-CODE
002290         BY REFERENCE BUFFER
002300         BY VALUE     BUF-LEN
002310      END-CALL
002320      DISPLAY BUFFER
002330      STOP RUN.
002340
002350 END PROGRAM READER2.
002360
002370
