*
* STATUS2.PRG
*
* Alaska Xbase++ "STATUS" program (for SEE 3.2) that uses seeDriver.
* This program lists all email waiting on the specified POP3 server.
*
* Note that the 4th argument to seeGetEmailLines is 0 rather than
* a buffer, which will force SEE to use its internal memory. This
* is necessary since otherwise Xbase++ may move its memory at runtime.
* After seeDriver completes running, the SEE internal buffer can be
* copied using seeDebug(Chan, SEE_COPY_BUFFER, ...).
*
* This precaution is ONLY necessary when using the SEE driver seeDriver.
* Compare this program to STATUS.PRG.
*
* PROGRAMMER:
*   (1) To compile: XPP STATUS2.PRG
*   (2) To link: ALINK STATUS2.OBJ SEE32.LIB
*

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "SEE32.CH"

Procedure Main()

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\status2.log"
*** END PROGRAMMER ***

? "DRIVER 2/21/2000"

if XseeAttach(1, SEE_KEY_CODE) < 0
  ? "Cannot attach SEE"
  return
endif
Code = XseeStringParam(0, SEE_LOG_FILE, @DiagFile)
* connect to POP3 server
? "Connecting to " + Pop3Server
* set maximum connect wait to 10 seconds
Code = XseeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
Code = XseePop3Connect(0,@Pop3Server, @Pop3UserName, @Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = XseeErrorText(0,Code,@Temp,128)
  ? Left(Temp,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMsg = XseeGetEmailCount(0)
  if NbrMsg < 0
    Temp = SPACE(128)
    Code = XseeErrorText(0,NbrMsg,@Temp,128)
    ? Left(Temp,Code)
  else
    ? NbrMsg," messages waiting."
    For I = 1 to NbrMsg
      ? "----- Message ", LTRIM(STR(I)) + " -----"
      * disable AUTO CALL
      Code = XseeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 0)
      * set up to get email lines
      Buffer = SPACE(5000)
      Code = XseeGetEmailLines(0, I, 0, @Buffer, 5000)
      * run the driver
      Do while .T.
        Code = XseeDriver(0)
        if Code = 0
          Exit
        endif
        if Code < 0
          Temp = SPACE(128)
          Code = XseeErrorText(0,Code,@Temp,128)
          ? Left(Temp,Code)
          Code = XseeClose(0)
          Code = XseeRelease()
          return
        endif
        nBytes = XseeStatistics(0, SEE_GET_TOTAL_BYTES_READ)
        ? nBytes, " bytes read"
      Enddo
      * re-enable AUTO CALL
      Code = XseeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 1)
      nBytes = XseeStatistics(0, SEE_GET_TOTAL_BYTES_READ)
      * display "DATE: " line
      Temp = SPACE(128)
      Code = XseeExtractText(@Buffer, "Date: ", @Temp, 128)
      if Code > 0
        ? Left(Temp,Code)
      endif
      * display "FROM: " line
      Temp = SPACE(128)
      Code = XseeExtractText(@Buffer, "From: ", @Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
      * display "SUBJECT: " line
      Temp = SPACE(128)
      Code = XseeExtractText(@Buffer, "Subject: ", @Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
    Endfor
   ? "----- END -----"
  endif
endif
? "Done."
Code = XseeClose(0)
Code = XseeRelease()
return

