Attribute VB_Name = "ContextIDs"
Option Explicit
'=====================================================================
'=====================================================================
'
'This source code contains the following routines:
'  o SetAppHelp() 'Called in the main Form_Load event to register your
'                 'program with WINHELP.EXE
'  o QuitHelp()    'Deregisters your program with WINHELP.EXE. Should
'                  'be called in your main Form_Unload event
'  o ShowHelpTopic(Topicnum) 'Brings up context sensitive help based on
'                  'any of the following CONTEXT IDs
'  o ShowContents  'Displays the startup topic
'  o HelpWindowSize(x,y,dx,dy) ' Position help window in a screen
'                              ' independent manner
'  o SearchHelp()  'Brings up the windows help KEYWORD SEARCH dialog box
'***********************************************************************
'
'=====================================================================
'List of Context IDs for <ScriptHelp>
'=====================================================================
Global Const conversion_functions = 30    'Main Help Window
Global Const asc = 40    'Main Help Window
Global Const chr = 50    'Main Help Window
Global Const hex = 60    'Main Help Window
Global Const str = 70    'Main Help Window
Global Const val = 80    'Main Help Window
Global Const data_types = 90    'Main Help Window
Global Const variable_declaration = 100    'Main Help Window
Global Const file_functions = 110    'Main Help Window
Global Const chdir = 120    'Main Help Window
Global Const cwd = 130    'Main Help Window
Global Const fclose = 140    'Main Help Window
Global Const fcloseall = 150    'Main Help Window
Global Const feof = 160    'Main Help Window
Global Const fgetc = 170    'Main Help Window
Global Const fgets = 180    'Main Help Window
Global Const fileexists = 190    'Main Help Window
Global Const filelen = 200    'Main Help Window
Global Const findfirst = 210    'Main Help Window
Global Const findnext = 220    'Main Help Window
Global Const fopen = 230    'Main Help Window
Global Const fputc = 240    'Main Help Window
Global Const fputs = 250    'Main Help Window
Global Const fseek = 260    'Main Help Window
Global Const ftell = 270    'Main Help Window
Global Const kill = 280    'Main Help Window
Global Const mkdir = 290    'Main Help Window
Global Const name = 300    'Main Help Window
Global Const rmdir = 310    'Main Help Window
Global Const math_functions = 320    'Main Help Window
Global Const abs = 330    'Main Help Window
Global Const acos = 340    'Main Help Window
Global Const asin = 350    'Main Help Window
Global Const atn = 360    'Main Help Window
Global Const cos = 370    'Main Help Window
Global Const exp = 380    'Main Help Window
Global Const exp10 = 390    'Main Help Window
Global Const exp2 = 400    'Main Help Window
Global Const int = 410    'Main Help Window
Global Const log = 420    'Main Help Window
Global Const log10 = 430    'Main Help Window
Global Const log2 = 440    'Main Help Window
Global Const sgn = 450    'Main Help Window
Global Const sin = 460    'Main Help Window
Global Const sqr = 470    'Main Help Window
Global Const tan = 480    'Main Help Window
Global Const __index = 490    'Main Help Window
Global Const string_functions = 500    'Main Help Window
Global Const instr = 510    'Main Help Window
Global Const lcase = 520    'Main Help Window
Global Const left = 530    'Main Help Window
Global Const len = 540    'Main Help Window
Global Const ltrim = 550    'Main Help Window
Global Const mid = 560    'Main Help Window
Global Const right = 570    'Main Help Window
Global Const rtrim = 580    'Main Help Window
Global Const trim = 590    'Main Help Window
Global Const ucase = 610    'Main Help Window
Global Const while = 670    'Main Help Window
Global Const not = 880    'Main Help Window
Global Const mod = 890    'Main Help Window
Global Const and = 900    'Main Help Window
Global Const rem = 910    'Main Help Window
Global Const label = 920    'Main Help Window
Global Const print = 980    'Main Help Window
Global Const if = 1010    'Main Help Window
Global Const stop = 1050    'Main Help Window
Global Const or = 1060    'Main Help Window
Global Const goto = 1080    'Main Help Window
Global Const for = 1100    'Main Help Window
Global Const break = 1110    'Main Help Window
Global Const continue = 1120    'Main Help Window
Global Const erase = 1230    'Main Help Window
Global Const dump = 1240    'Main Help Window
Global Const gosub = 1250    'Main Help Window
Global Const end = 1290    'Main Help Window
Global Const operators = 1300    'Main Help Window
Global Const reserved_words = 1350    'Main Help Window
Global Const statements = 1360    'Main Help Window
Global Const precedence = 1370    'Main Help Window
Global Const GLOS_numeric_expression =  1380
Global Const GLOS_string_expression =  1390
Global Const GLOS_file_index =  1400
Global Const GLOS_path =  1410
Global Const GLOS_wildcard_characters =  1420
Global Const GLOS_filespec =  1430
Global Const GLOS_character =  1440
Global Const GLOS_whitespace =  1450
Global Const GLOS_LValue =  1460
Global Const GLOS_expression =  1470
Global Const GLOSSARY = 64000
'=====================================================================
'
'
'  Help engine section.

' Commands to pass WinHelp()
Global Const HELP_CONTEXT = &H1 '  Display topic in ulTopic
Global Const HELP_QUIT = &H2    '  Terminate help
Global Const HELP_FINDER = &HB  '  Display Contents tab
Global Const HELP_INDEX = &H3   '  Display index
Global Const HELP_HELPONHELP = &H4      '  Display help on using help
Global Const HELP_SETINDEX = &H5        '  Set the current Index for multi index help
Global Const HELP_KEY = &H101           '  Display topic for keyword in offabData
Global Const HELP_MULTIKEY = &H201
Global Const HELP_CONTENTS = &H3     ' Display Help for a particular topic
Global Const HELP_SETCONTENTS = &H5  ' Display Help contents topic
Global Const HELP_CONTEXTPOPUP = &H8 ' Display Help topic in popup window
Global Const HELP_FORCEFILE = &H9    ' Ensure correct Help file is displayed
Global Const HELP_COMMAND = &H102    ' Execute Help macro
Global Const HELP_PARTIALKEY = &H105 ' Display topic found in keyword list
Global Const HELP_SETWINPOS = &H203  ' Display and position Help window

    Type HELPWININFO
      wStructSize As Long
      X As Long
      Y As Long
      dX As Long
      dY As Long
      wMax As Long
      rgChMember As String * 2
    End Type
    Declare Function WinHelp Lib "User32.dll" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Any) As Long
    Declare Function WinHelpByInfo Lib "User32.dll" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, dwData As HELPWININFO) As Long
    Declare Function WinHelpByStr Lib "User32.dll" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData$) As Long
    Declare Function WinHelpByNum Lib "User32.dll" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData&) As Long
    Dim m_hWndMainWindow as Long ' hWnd to tell WINHELP the helpfile owner

Dim MainWindowInfo as HELPWININFO
Public Sub SetAppHelp (ByVal hWndMainWindow)
'=====================================================================
'To use these subroutines to access WINHELP, you need to add
'at least this one subroutine call to your code
'     o  In the Form_Load event of your main Form enter:
'        Call SetAppHelp(Me.hWnd) 'To setup helpfile variables
'         (If you are not interested in keyword searching or context
'         sensitive help, this is the only call you need to make!)
'=====================================================================
    m_hWndMainWindow = hWndMainWindow
    If Right$(Trim$(App.Path),1) = "\" then
        App.HelpFile = App.Path + "ScriptHelp.HLP"
    else
        App.HelpFile = App.Path + "\ScriptHelp.HLP"
    end if
    MainWindowInfo.wStructSize = 26
    MainWindowInfo.X=256
    MainWindowInfo.Y=256
    MainWindowInfo.dX=512
    MainWindowInfo.dY=512
    MainWindowInfo.rgChMember=Chr$(0)+Chr$(0)
End Sub
Public Sub QuitHelp ()
    Dim Result as Variant
    Result = WinHelp(m_hWndMainWindow, App.HelpFile, HELP_QUIT, Chr$(0) + Chr$(0) + Chr$(0) + Chr$(0))
End Sub
Public Sub ShowHelpTopic (ByVal ContextID As Long)
'=====================================================================
'  FOR CONTEXT SENSITIVE HELP IN RESPONSE TO A COMMAND BUTTON ...
'=====================================================================
'     o   For 'Help button' controls, you can call:
'         Call ShowHelpTopic(<any Hlpxxx entry above>)
'=====================================================================
'  TO ADD FORM LEVEL CONTEXT SENSITIVE HELP...
'=====================================================================
'     o  For FORM level context sensetive help, you should set each 
'        Me.HelpContext=<any Hlp_xxx entry above>
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_CONTEXT, Clng(ContextID))

End Sub
Public Sub ShowHelpTopic2 (ByVal ContextID As Long)
'=====================================================================
'  DISPLAY CONTEXT SENSITIVE HELP IN WINDOW 2 ...
'=====================================================================
'     o   For 'Help button' controls, you can call:
'         Call ShowHelpTopic2(<any Hlpxxx entry above>)
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile &">HlpWnd02", HELP_CONTEXT, Clng(ContextID))

End Sub
Public Sub ShowHelpTopic3 (ByVal ContextID As Long)
'=====================================================================
'  DISPLAY CONTEXT SENSITIVE HELP IN WINDOW 3 ...
'=====================================================================
'     o   For 'Help button' controls, you can call:
'         Call ShowHelpTopic3(<any Hlpxxx entry above>)
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile &">HlpWnd03", HELP_CONTEXT, Clng(ContextID))

End Sub
Public Sub ShowGlossary ()
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_CONTEXT, Clng(64000))

End Sub
Public Sub ShowPopupHelp (ByVal ContextID As Long)
'=====================================================================
'  FOR POPUP HELP IN RESPONSE TO A COMMAND BUTTON ...
'=====================================================================
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_CONTEXTPOPUP, Clng(ContextID))

End Sub
Public Sub DoHelpMacro (ByVal MacroString As String)
'=====================================================================
'  FOR POPUP HELP IN RESPONSE TO A COMMAND BUTTON ...
'=====================================================================
    Dim Result as Variant

    Result = WinHelpByStr(m_hWndMainWindow, APP.HelpFile, HELP_COMMAND, ByVal(Macrostring))

End Sub
Public Sub ShowHelpContents ()
'=====================================================================
'  DISPLAY STARTUP TOPIC IN RESPONSE TO A COMMAND BUTTON or MENU ...
'=====================================================================
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_CONTENTS, Clng(0))

End Sub
Public Sub ShowContentsTab ()
'=====================================================================
'  DISPLAY Contents tab (*.CNT)
'=====================================================================
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_FINDER, Clng(0))

End Sub
Public Sub ShowHelpOnHelp ()
'=====================================================================
'  DISPLAY HELP for WINHELP.EXE  ...
'=====================================================================
'
    Dim Result as Variant

    Result = WinHelpByNum(m_hWndMainWindow, APP.HelpFile, HELP_HELPONHELP, Clng(0))

End Sub

Public Sub SearchHelp ()
'=====================================================================
'  TO ADD KEYWORD SEARCH CAPABILITY...
'=====================================================================
'     o   In your Help|Search menu selection, simply enter:
'         Call SearchHelp() 'To invoke helpfile keyword search dialog
'
    Dim Result as Variant

    Result = WinHelp(m_hWndMainWindow, APP.HelpFile, HELP_PARTIALKEY, ByVal "" )

End Sub

Public Sub SearchHelpKeyWord (Argument as String)
'=====================================================================
'  TO ADD KEYWORD SEARCH CAPABILITY...
'=====================================================================
'     o   In your Help|Search menu selection, simply enter:
'         Call SearchHelp() 'To invoke helpfile keyword search dialog
'
    Dim Result as Variant

    Result = WinHelp(m_hWndMainWindow, APP.HelpFile, HELP_PARTIALKEY, ByVal Trim$(Argument))

End Sub
Public Sub HelpWindowSize (x As Integer, y As Integer, wx As Integer, wy As Integer)
'=====================================================================
'  TO SET THE SIZE AND POSITION OF THE MAIN HELP WINDOW...
'=====================================================================
'     o   Call HelpWindowSize(x, y, dx, dy), where:
'             x = 1-1024 (position from left edge of screen)
'             y = 1-1024 (position from top of screen)
'             dx= 1-1024 (width)
'             dy= 1-1024 (height)
'
    Dim Result as Variant
    MainWindowInfo.x = x
    MainWindowInfo.y = y
    MainWindowInfo.dx = wx
    MainWindowInfo.dy = wy
    Result = WinHelpByInfo(m_hWndMainWindow, App.HelpFile, HELP_SETWINPOS, MainWindowInfo)
End Sub
