// QuickTagCompilerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "QuickTagCompiler.h"
#include "QuickTagCompilerDlg.h"
#include <initguid.h>
#include "qtwrapper_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQuickTagCompilerDlg dialog

CQuickTagCompilerDlg::CQuickTagCompilerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQuickTagCompilerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CQuickTagCompilerDlg)
	m_strSentences = _T("Paste a sentence or paragraph here for the functions \"tag a sentence\" and \"tag a paragraph\".");
	m_strResult = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_lQuickTagAnalysis=0;
	m_iCurrentSent=0;
	m_iSentCount=0;
	m_iAlt=1;
	m_iLongN=1;
	::CoInitialize(NULL);
}

CQuickTagCompilerDlg::~CQuickTagCompilerDlg()
{
	m_pIQuickTag.Release();
	::CoUninitialize();
}

void CQuickTagCompilerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQuickTagCompilerDlg)
	DDX_Control(pDX, IDC_SENTENCES, m_edSentence);
	DDX_Control(pDX, IDC_PREV, m_bPrev);
	DDX_Control(pDX, IDC_NEXT, m_bNext);
	DDX_Control(pDX, IDC_CURRENT_SENTENCE, m_edCurSent);
	DDX_Control(pDX, IDC_NUMBER_SENTENCES, m_edSentCount);
	DDX_Control(pDX, IDC_RESULT, m_edResult);
	DDX_Text(pDX, IDC_SENTENCES, m_strSentences);
	DDX_Text(pDX, IDC_RESULT, m_strResult);
	DDX_Check(pDX, IDC_ALT, m_iAlt);
	DDX_Check(pDX, IDC_LONGNAMES, m_iLongN);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CQuickTagCompilerDlg, CDialog)
	//{{AFX_MSG_MAP(CQuickTagCompilerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_TAG_TEXTFILE, OnTagTextfile)
	ON_BN_CLICKED(IDC_TAG_HTMLFILE, OnTagHtmlfile)
	ON_BN_CLICKED(IDC_TAG_SENTENCE, OnTagSentence)
	ON_BN_CLICKED(IDC_TAG_PARAGRAPH, OnTagParagraph)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_COMPILE, OnCompile)
	ON_BN_CLICKED(IDC_ALT, OnAlt)
	ON_BN_CLICKED(IDC_LONGNAMES, OnLongNames)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQuickTagCompilerDlg message handlers

BOOL CQuickTagCompilerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetWindowRect(&m_rcLoadRect);
	CRect rcResult;
	m_edResult.GetWindowRect(&rcResult);
	m_szRBMargin.cx=m_rcLoadRect.right-rcResult.right;
	m_szRBMargin.cy=m_rcLoadRect.bottom-rcResult.bottom;

	HRESULT hr=m_pIQuickTag.CoCreateInstance(CLSID_QuickTag);
	if((FAILED(hr)) || !m_pIQuickTag) {
		AfxMessageBox("Unable to create the instance of COM object!");
		EndDialog(hr);
		return FALSE;
	}

	char strFullPath[_MAX_PATH];
	char strPath[_MAX_PATH];
	*strFullPath=0;
	*strPath=0;
	if (::GetModuleFileName(::AfxGetInstanceHandle(),(char*)&strPath,sizeof(strPath)))
	{
		char*  lpFilePart;
		::GetFullPathName(strPath,sizeof(strPath),(char*) &strPath,&lpFilePart);	
		*lpFilePart=(char)0;
	}
	strncat(strPath,"Data\\Quicktag.dat",sizeof(strPath));
	CString str(strPath);
	BSTR bstr=str.AllocSysString();
	hr=m_pIQuickTag->QT_Initialize(bstr);
	::SysFreeString(bstr);
	if(FAILED(hr)) {
		AfxMessageBox("Unable to Initialize QuickTag Engine!");
		EndDialog(hr);
		return FALSE;
	}
	UpdateSentenceStatus();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CQuickTagCompilerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CQuickTagCompilerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CQuickTagCompilerDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnGetMinMaxInfo(lpMMI);
	CPoint minSize(m_rcLoadRect.Size());

	lpMMI->ptMinTrackSize=minSize;
}

void CQuickTagCompilerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	CRect rcDlgRect;
	GetWindowRect(&rcDlgRect);
	if (IsWindow(m_edResult.m_hWnd))
	{
		CRect rcResult;
		m_edResult.GetWindowRect(&rcResult);
		rcResult.right=rcDlgRect.right-m_szRBMargin.cx;
		rcResult.bottom=rcDlgRect.bottom-m_szRBMargin.cy;
		ScreenToClient(&rcResult);
		m_edResult.SetWindowPos(NULL,rcResult.left,rcResult.top,rcResult.Width(),rcResult.Height(),SWP_NOZORDER);
	}
	
}

void CQuickTagCompilerDlg::OnTagTextfile() 
{
	CFileDialog cdTxtFileDialog(TRUE,"txt",NULL,
		OFN_HIDEREADONLY | OFN_EXPLORER | OFN_FILEMUSTEXIST |OFN_ENABLESIZING | OFN_PATHMUSTEXIST,
		"Text Files (*.txt)|*.txt|All Files (*.*)|*.*||",
		this);
	if (cdTxtFileDialog.DoModal()==IDOK)
	{
		if (m_lQuickTagAnalysis)
		{
			m_pIQuickTag->QT_Delete(m_lQuickTagAnalysis);
			m_lQuickTagAnalysis=0;
		}
		CString str(cdTxtFileDialog.GetPathName());
		BSTR bstr=str.AllocSysString();
		HRESULT hr=m_pIQuickTag->QT_TagTextFile(bstr,&m_lQuickTagAnalysis);
		::SysFreeString(bstr);
		if (SUCCEEDED(hr) && m_lQuickTagAnalysis)
		{
			hr=m_pIQuickTag->QT_SentenceCount(m_lQuickTagAnalysis,&m_iSentCount);
			m_iCurrentSent=0;
			UpdateSentenceStatus();
		}
	}
}

void CQuickTagCompilerDlg::OnTagHtmlfile() 
{
	CFileDialog cdHTMLFileDialog(TRUE,"htm",NULL,
		OFN_HIDEREADONLY | OFN_EXPLORER | OFN_FILEMUSTEXIST |OFN_ENABLESIZING | OFN_PATHMUSTEXIST,
		"Internet Files (*.htm; *.html)|*.htm; *.html|All Files (*.*)|*.*||",
		this);
	if (cdHTMLFileDialog.DoModal()==IDOK)
	{
		if (m_lQuickTagAnalysis)
		{
			m_pIQuickTag->QT_Delete(m_lQuickTagAnalysis);
			m_lQuickTagAnalysis=0;
		}
		CString str(cdHTMLFileDialog.GetPathName());
		BSTR bstr=str.AllocSysString();
		HRESULT hr=m_pIQuickTag->QT_TagHtmlFile(bstr,&m_lQuickTagAnalysis);
		::SysFreeString(bstr);
		if (SUCCEEDED(hr) && m_lQuickTagAnalysis)
		{
			hr=m_pIQuickTag->QT_SentenceCount(m_lQuickTagAnalysis,&m_iSentCount);
			m_iCurrentSent=0;
			UpdateSentenceStatus();
		}
	}
	
}

void CQuickTagCompilerDlg::SetResultString(LPCSTR strNewValue)
{
	m_edResult.SetWindowText(strNewValue);
}

void CQuickTagCompilerDlg::UpdateSentenceStatus()
{
	if ((m_iCurrentSent==0)&&(m_iSentCount>0))
	{
		//m_iCurrentSent=1;
	}
	CString str="n/a";
	if (m_iCurrentSent>=0 && m_iSentCount>0)
	{
		str.Format("%d",m_iCurrentSent+1);
	}
	m_edCurSent.SetWindowText(str);
	str.Format("%d",m_iSentCount);
	m_edSentCount.SetWindowText(str);
	m_bPrev.EnableWindow(m_iCurrentSent>0);
	m_bNext.EnableWindow(m_iCurrentSent<m_iSentCount-1);
	Analysis();
}

void CQuickTagCompilerDlg::Analysis()
{
	if (m_lQuickTagAnalysis==0) 
		return;
	BSTR bstr;
	CString strResultString;
	CString str;
	strResultString="ORIGINAL SENTENCE:";
	short iResult;
	m_pIQuickTag->QT_GetSentence(m_lQuickTagAnalysis, m_iCurrentSent, &bstr, &iResult);	// gets the sentence
	if (iResult==1) 
	{
		str=bstr; 
	}
	else
	{
		str="";
	}
	::SysFreeString(bstr);
	m_edSentence.SetWindowText(str); // displays it in the input window
	strResultString+="\r\n"+str+"\r\n\r\nQUICKTAG ANALYSIS:"; // displays it in the output window
	short iTokenCount;
	m_pIQuickTag->QT_TokenCount(m_lQuickTagAnalysis,m_iCurrentSent,&iTokenCount); // gets the number of words
	str.Format("\r\n\r\nNumber of Words: %d\r\n",iTokenCount); // displays the number of words
	strResultString+=str;

	// Analyse of CheckBoxes:
	bool bLongNames;
	bool bAltTagSet;
	LONG lState=SendDlgItemMessage(IDC_ALT,BM_GETSTATE,0,0);
	bAltTagSet=((lState & BST_CHECKED)!=0);
	lState=SendDlgItemMessage(IDC_LONGNAMES,BM_GETSTATE,0,0);
	bLongNames=((lState & BST_CHECKED)!=0);

	// now for each word
	for (int i = 0; i < iTokenCount; i++)
	{
		strResultString+="\t";
		m_pIQuickTag->QT_GetToken(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);	// get the word
		if (iResult==1) {str=bstr;} else {str="";}; ::SysFreeString(bstr);
		strResultString+=str+"\t";

		m_pIQuickTag->QT_GetLemma(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);   // get the root
		if (iResult==1) {str=bstr;} else {str="";};
		strResultString+=str+"\t";

		if (bLongNames && bAltTagSet)
		{
			m_pIQuickTag->QT_GetLongPOS(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		}

		if (!bLongNames && bAltTagSet)
		{
			m_pIQuickTag->QT_GetShortPOS(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		}

		if (bLongNames && !bAltTagSet)
		{
			m_pIQuickTag->QT_GetLongOrgPOS(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		}

		if (!bLongNames && !bAltTagSet)
		{
			m_pIQuickTag->QT_GetLongOrgPOS(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		}
		if (iResult==1) {str=bstr;} else {str="";}; ::SysFreeString(bstr);
		strResultString+=str+"\t";

		// gets and displays all flags
		short iFC;
		m_pIQuickTag->QT_GetFlagCounts(m_lQuickTagAnalysis, m_iCurrentSent, i, &iFC);
		for (int j = 0; j < iFC; j++)
		{
			m_pIQuickTag->QT_GetFlag(m_lQuickTagAnalysis, m_iCurrentSent, i, j, &bstr, &iResult);  // displays all tags separated by commas
			if (iResult==1) {str=bstr;} else {str="";}; ::SysFreeString(bstr);
			if (j) strResultString+=",";
			strResultString+=str;
		}
		strResultString+="\r\n";
	}
	// now let's display all noun phrases
	short iNouns=0;
	m_pIQuickTag->QT_NounPhraseCount(m_lQuickTagAnalysis, m_iCurrentSent, &iNouns);
	str.Format("Number of Noun Phrases: %d\r\n",iNouns);
	strResultString+=str;
	for (i = 0; i < iNouns; i++)
	{
		strResultString+="\t[";
		m_pIQuickTag->QT_GetNounPhrase(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		if (iResult==1) {str=bstr;} else {str="";}; ::SysFreeString(bstr);
		strResultString+=str+"]\t[";
		m_pIQuickTag->QT_GetLemmaNounPhrase(m_lQuickTagAnalysis, m_iCurrentSent, i, &bstr, &iResult);
		if (iResult==1) {str=bstr;} else {str="";}; ::SysFreeString(bstr);
		strResultString+=str+"]\t";
		short iProper=0;
		m_pIQuickTag->QT_NounPhraseIsProper(m_lQuickTagAnalysis, m_iCurrentSent, i, &iProper);
		if (iProper)
			strResultString+="\tProper";
		strResultString+="\r\n";
	}
	SetResultString(strResultString);

}

void CQuickTagCompilerDlg::OnTagSentence() 
{
	if (m_lQuickTagAnalysis)
	{
		m_pIQuickTag->QT_Delete(m_lQuickTagAnalysis);
		m_lQuickTagAnalysis=0;
	}
	CString str;
	m_edSentence.GetWindowText(str);
	BSTR bstr=str.AllocSysString();
	HRESULT hr=m_pIQuickTag->QT_TagSentence(bstr,&m_lQuickTagAnalysis);
	::SysFreeString(bstr);
	if (SUCCEEDED(hr) && m_lQuickTagAnalysis)
	{
		hr=m_pIQuickTag->QT_SentenceCount(m_lQuickTagAnalysis,&m_iSentCount);
		m_iCurrentSent=0;
		UpdateSentenceStatus();
	}
	
}

void CQuickTagCompilerDlg::OnTagParagraph() 
{
	if (m_lQuickTagAnalysis)
	{
		m_pIQuickTag->QT_Delete(m_lQuickTagAnalysis);
		m_lQuickTagAnalysis=0;
	}
	CString str;
	m_edSentence.GetWindowText(str);
	BSTR bstr=str.AllocSysString();
	HRESULT hr=m_pIQuickTag->QT_TagParagraph(bstr,&m_lQuickTagAnalysis);
	::SysFreeString(bstr);
	if (SUCCEEDED(hr) && m_lQuickTagAnalysis)
	{
		hr=m_pIQuickTag->QT_SentenceCount(m_lQuickTagAnalysis,&m_iSentCount);
		m_iCurrentSent=0;
		UpdateSentenceStatus();
	}
	
}

void CQuickTagCompilerDlg::OnPrev() 
{
	if (m_iCurrentSent>0) m_iCurrentSent--;
	UpdateSentenceStatus();
	
}

void CQuickTagCompilerDlg::OnAlt() 
{
	UpdateSentenceStatus();
	
}

void CQuickTagCompilerDlg::OnLongNames() 
{
	UpdateSentenceStatus();
	
}

void CQuickTagCompilerDlg::OnNext() 
{
	if (m_iCurrentSent<(m_iSentCount-1)) m_iCurrentSent++;
	UpdateSentenceStatus();
}

void CQuickTagCompilerDlg::OnCompile() 
{
	CWaitCursor w;
	short iResult=0;
	BSTR bstr;
	char strFullPath[_MAX_PATH];
	char strPath[_MAX_PATH];
	*strFullPath=0;
	*strPath=0;
	if (::GetModuleFileName(::AfxGetInstanceHandle(),(char*)&strPath,sizeof(strPath)))
	{
		char*  lpFilePart;
		::GetFullPathName(strPath,sizeof(strPath),(char*) &strPath,&lpFilePart);	
		*lpFilePart=(char)0;
	}
	CString inFolder=strPath;
	CString outFile=inFolder+"\\Data\\QuickTag.dat";
	CString str;
	SetResultString("Compiling...");
	m_edResult.UpdateWindow();
	BSTR bstr1=inFolder.AllocSysString();
	BSTR bstr2=outFile.AllocSysString();
	m_pIQuickTag->QT_CompileData(bstr1,bstr2,0,&bstr,&iResult);
	::SysFreeString(bstr1);
	::SysFreeString(bstr2);
	if (bstr) str=bstr;
	::SysFreeString(bstr);
	SetResultString(str);
}