Attribute VB_Name = "ScriptExtensions"
Option Explicit

Public Const MAX_USER_DEFINED_FUNCS = 254 ' Ordinals numbered 1 through 254
Public Const MyFuncsCount = 8

Public Const MAX_USER_DEFINED_VARS = 100 ' There is no "hard" limit as there is with functions.
Public Const MyVarsCount = 0

Public Type tUserDefinedFunction
    KeyWord As String
    ParamCount As Long
    Ordinal As Long
    ReturnType As TxTypes
End Type

Public Type tUserDefinedVar
    VarName As String
    VarType As TxTypes
    InitialValue As Variant
End Type

Public Sub DefineMyVars(TLC As TLang)
' -- Generic function - not used in this example
'    Dim MyVars(MAX_USER_DEFINED_VARS) As tUserDefinedVar
'    Dim i As Integer
    
'    For i = 0 To MyVarsCount - 1
'        TLC.AddVariable MyVars(i).VarName, MyVars(i).VarType, MyVars(i).InitialValue
'    Next i
End Sub

Public Sub DefineMyFunctions(TLC As TLang)

    Dim i As Integer
    Dim MyFuncs(MAX_USER_DEFINED_FUNCS) As tUserDefinedFunction
    
    MyFuncs(0).KeyWord = "Circle"
    MyFuncs(0).Ordinal = 1
    MyFuncs(0).ParamCount = 4
    MyFuncs(0).ReturnType = TxNone
        
    MyFuncs(1).KeyWord = "Square"
    MyFuncs(1).Ordinal = 2
    MyFuncs(1).ParamCount = 5
    MyFuncs(1).ReturnType = TxNone
    
    MyFuncs(2).KeyWord = "Line"
    MyFuncs(2).Ordinal = 3
    MyFuncs(2).ParamCount = 5
    MyFuncs(2).ReturnType = TxNone
    
    MyFuncs(3).KeyWord = "Clear"
    MyFuncs(3).Ordinal = 4
    MyFuncs(3).ParamCount = 0
    MyFuncs(3).ReturnType = TxNone
    
    MyFuncs(4).KeyWord = "Rnd"
    MyFuncs(4).Ordinal = 5
    MyFuncs(4).ParamCount = 1
    MyFuncs(4).ReturnType = TxNumber
    
    MyFuncs(5).KeyWord = "Color"
    MyFuncs(5).Ordinal = 6
    MyFuncs(5).ParamCount = 3
    MyFuncs(5).ReturnType = TxNumber
    
    MyFuncs(6).KeyWord = "FillColor"
    MyFuncs(6).Ordinal = 7
    MyFuncs(6).ParamCount = 1
    MyFuncs(6).ReturnType = TxNone
    
    MyFuncs(7).KeyWord = "FillStyle"
    MyFuncs(7).Ordinal = 8
    MyFuncs(7).ParamCount = 1
    MyFuncs(7).ReturnType = TxNone
    
    For i = 0 To MyFuncsCount - 1
        TLC.AddFunction MyFuncs(i).KeyWord, MyFuncs(i).ParamCount, MyFuncs(i).Ordinal, MyFuncs(i).ReturnType
    Next i
    
End Sub

Public Sub Def_Circle(TLC As TLang, Pic As PictureBox)

    Dim CX As Double
    Dim CY As Double
    Dim dRadius As Double
    Dim dColor As Double
    
    TLC.GetNParam 1, CX
    TLC.GetNParam 2, CY
    TLC.GetNParam 3, dRadius
    TLC.GetNParam 4, dColor
    
    Pic.Circle (CX, CY), dRadius, dColor

End Sub

Public Sub Def_Square(TLC As TLang, Pic As PictureBox)

    Dim x1 As Double
    Dim y1 As Double
    Dim x2 As Double
    Dim y2 As Double
    Dim dColor As Double
    
    TLC.GetNParam 1, x1
    TLC.GetNParam 2, y1
    TLC.GetNParam 3, x2
    TLC.GetNParam 4, y2
    TLC.GetNParam 5, dColor
    
    Pic.Line (x1, y1)-(x2, y2), dColor, BF
    
End Sub

Public Sub Def_Line(TLC As TLang, Pic As PictureBox)

    Dim x1 As Double
    Dim y1 As Double
    Dim x2 As Double
    Dim y2 As Double
    Dim dColor As Double
    
    TLC.GetNParam 1, x1
    TLC.GetNParam 2, y1
    TLC.GetNParam 3, x2
    TLC.GetNParam 4, y2
    TLC.GetNParam 5, dColor
    
    Pic.Line (x1, y1)-(x2, y2), dColor
    
End Sub

Public Sub Def_Clear(TLC As TLang, Pic As PictureBox)

    Pic.Cls
    
End Sub

Public Sub Def_Rnd(TLC As TLang)

    Dim dNumber As Double
    Dim RetVal As Double
    
    TLC.GetNParam 1, dNumber
    
    RetVal = Int((dNumber * Rnd) + 1)
    
    TLC.UserNReturn = RetVal
    
    Exit Sub
    
End Sub

Public Sub Def_Color(TLC As TLang)

    Dim dRed As Double
    Dim dGreen As Double
    Dim dBlue As Double
    
    TLC.GetNParam 1, dRed
    TLC.GetNParam 2, dGreen
    TLC.GetNParam 3, dBlue
    
    TLC.UserNReturn = RGB(dRed, dGreen, dBlue)
    
End Sub

Public Sub Def_FillColor(TLC As TLang, Pic As PictureBox)

    Dim dColor As Double
    
    TLC.GetNParam 1, dColor
    
    Pic.FillColor = dColor
    
End Sub

Public Sub Def_FillStyle(TLC As TLang, Pic As PictureBox)

    Dim dStyle As Double
    
    TLC.GetNParam 1, dStyle
    
    If dStyle < 0 Or dStyle > 7 Then
        dStyle = 0
    End If
    
    Pic.FillStyle = dStyle
        
End Sub
