Attribute VB_Name = "ScriptExtensions"
Option Explicit

Public Const MAX_USER_DEFINED_FUNCS = 254 ' Ordinals numbered 1 through 254
Public Const MyFuncsCount = 2

Public Const MAX_USER_DEFINED_VARS = 100 ' There is no "hard" limit as there is with functions.
Public Const MyVarsCount = 0

Public Type tUserDefinedFunction
    KeyWord As String
    ParamCount As Long
    Ordinal As Long
    ReturnType As TxTypes
End Type

Public Type tUserDefinedVar
    VarName As String
    VarType As TxTypes
    InitialValue As Variant
End Type

Public Sub DefineMyFunctions(TLC As TLang)
    Dim i As Integer
    Dim MyFuncs(MAX_USER_DEFINED_FUNCS) As tUserDefinedFunction
    
    MyFuncs(0).KeyWord = "Input_Box"
    MyFuncs(0).Ordinal = 1
    MyFuncs(0).ParamCount = 2
    MyFuncs(0).ReturnType = TxString
        
    MyFuncs(1).KeyWord = "Common_Dialog"
    MyFuncs(1).Ordinal = 2
    MyFuncs(1).ParamCount = 2
    MyFuncs(1).ReturnType = TxString
    
    For i = 0 To MyFuncsCount - 1
        TLC.AddFunction MyFuncs(i).KeyWord, MyFuncs(i).ParamCount, MyFuncs(i).Ordinal, MyFuncs(i).ReturnType
    Next i
End Sub

Public Sub Input_Box(TLC As TLang)
    
    'We are only going to use the first two parameters of inputbox
    Dim sPrompt As String
    Dim sTitle As String
    
    TLC.GetSParam 1, sPrompt
    TLC.GetSParam 2, sTitle
    TLC.UserSReturn = InputBox(sPrompt, sTitle)

End Sub

Public Sub Common_Dialog(TLC As TLang, UCD As CommonDialog)

    'Example using common dialog
    'Let's only use the open and save options
    Dim sTitle As String
    Dim sType As String
    
    TLC.GetSParam 1, sTitle
    TLC.GetSParam 2, sType
    
    UCD.CancelError = True
    UCD.DialogTitle = sTitle
    
    On Error Resume Next
    Select Case UCase(sType)
    
        Case "OPEN"
            UCD.ShowOpen
        
        Case "SAVE"
            UCD.ShowSave
            
        Case Else
            MsgBox "There is no " & sType & " common dialog."
            Exit Sub
            
    End Select
    
    If Err.Number = 0 Then
        TLC.UserSReturn = UCD.FileName
    End If
    On Error GoTo 0
    
End Sub
