Attribute VB_Name = "ScriptExtensions"
Option Explicit

Public Const MAX_USER_DEFINED_FUNCS = 254 ' Ordinals numbered 1 through 254
Public Const MyFuncsCount = 1

Public Const MAX_USER_DEFINED_VARS = 100 ' There is no "hard" limit as there is with functions.
Public Const MyVarsCount = 10

Public Type tUserDefinedFunction
    KeyWord As String
    ParamCount As Long
    Ordinal As Long
    ReturnType As TxTypes
End Type

Public Type tUserDefinedVar
    VarName As String
    VarType As TxTypes
    InitialValue As Variant
End Type

Public Sub DefineMyVars(TLC As TLang)
    Dim MyVars(MAX_USER_DEFINED_VARS) As tUserDefinedVar
    Dim i As Integer
    
    MyVars(0).VarName = "Strength"
    MyVars(0).VarType = TxNumber
    
    MyVars(1).VarName = "Dexterity"
    MyVars(1).VarType = TxNumber
    
    MyVars(2).VarName = "Constitution"
    MyVars(2).VarType = TxNumber
    
    MyVars(3).VarName = "Intelligence"
    MyVars(3).VarType = TxNumber
    
    MyVars(4).VarName = "Wisdom"
    MyVars(4).VarType = TxNumber
    
    MyVars(5).VarName = "Charisma"
    MyVars(5).VarType = TxNumber
    
    MyVars(6).VarName = "InOrder"
    MyVars(6).VarType = TxString
    
    MyVars(7).VarName = "NumTempRolls"
    MyVars(7).VarType = TxNumber
    
    MyVars(8).VarName = "DropAction"
    MyVars(8).VarType = TxString
    
    MyVars(9).VarName = "MaxScore"
    MyVars(9).VarType = TxNumber
    
    For i = 0 To MyVarsCount - 1
        TLC.AddVariable MyVars(i).VarName, MyVars(i).VarType
    Next i
    
    TLC.AddArray "TempRoll", TxNumber, 23
    
End Sub

Public Sub DefineMyFunctions(TLC As TLang)
    Dim i As Integer
    Dim MyFuncs(MAX_USER_DEFINED_FUNCS) As tUserDefinedFunction
    
    MyFuncs(0).KeyWord = "RndDie"
    MyFuncs(0).Ordinal = 1
    MyFuncs(0).ParamCount = 2
    MyFuncs(0).ReturnType = TxNumber
    
        
    For i = 0 To MyFuncsCount - 1
        TLC.AddFunction MyFuncs(i).KeyWord, MyFuncs(i).ParamCount, MyFuncs(i).Ordinal, MyFuncs(i).ReturnType
    Next i
    
End Sub

Public Sub RndDie(TLC As TLang)
    Dim Max As Double
    Dim Min As Double
    Dim RetVal As Double
    
    TLC.GetNParam 1, Max
    TLC.GetNParam 2, Min
    RetVal = Int((Max * Rnd) + 1)
    
    If RetVal < Min Then
        RetVal = Min
    End If
    
    TLC.UserNReturn = RetVal
    
    Exit Sub
    
End Sub
