Attribute VB_Name = "ScriptExtensions"
Option Explicit

Public Const MAX_USER_DEFINED_FUNCS = 254 ' Ordinals numbered 1 through 254
Public Const MyFuncsCount = 4 'Remember to set this value

Public Const MAX_USER_DEFINED_VARS = 100 ' There is no "hard" limit as there is with functions.
Public Const MyVarsCount = 2 'Remember to set this value

Public Type tUserDefinedFunction
    KeyWord As String
    ParamCount As Long
    Ordinal As Long
    ReturnType As TxTypes
End Type

Public Type tUserDefinedVar
    VarName As String
    VarType As TxTypes
End Type

Public Sub DefineMyVars(TLC As TLang)
    
    Dim MyVarS(MAX_USER_DEFINED_VARS) As tUserDefinedVar
    Dim i As Integer
    
    MyVarS(0).VarName = "MyNumber"
    MyVarS(0).VarType = TxNumber
    
    MyVarS(1).VarName = "MyString"
    MyVarS(1).VarType = TxString
    
' Testing the control
'    MyVarS(2).VarName = "if"
'    MyVarS(2).VarType = TxString
        
    For i = 0 To MyVarsCount - 1
        'Adds user defined variables to the script language
        TLC.AddVariable MyVarS(i).VarName, MyVarS(i).VarType
    Next i
    'Adds a numeric array with 10 elements (0-9) to the script language
    TLC.AddArray "MyNumericArray", TxNumber, 9
    'Adds a string array with 10 elements (0-9) to the script language
    TLC.AddArray "MyStringArray", TxString, 9
    
End Sub

Public Sub DefineMyFunctions(TLC As TLang)

    Dim i As Integer
    Dim MyFuncs(MAX_USER_DEFINED_FUNCS) As tUserDefinedFunction
    
    MyFuncs(0).KeyWord = "Date" 'This is the keyword that is being added to the script language
                                'The
    MyFuncs(0).Ordinal = 1  'Ordinal number that is used in the select case defined in the
                            'OnUserFunction event in frmBuildScript
    MyFuncs(0).ParamCount = 1 'Number of parameters in the function
    MyFuncs(0).ReturnType = TxString 'The type that the function will return
                                     'There are three return types: TxNumber, TxString and TxNone
    MyFuncs(1).KeyWord = "Time"
    MyFuncs(1).Ordinal = 2
    MyFuncs(1).ParamCount = 1
    MyFuncs(1).ReturnType = TxString
    
    MyFuncs(2).KeyWord = "GetSeconds"
    MyFuncs(2).Ordinal = 3
    MyFuncs(2).ParamCount = 2
    MyFuncs(2).ReturnType = TxNumber
    
    MyFuncs(3).KeyWord = "Wait"
    MyFuncs(3).Ordinal = 4
    MyFuncs(3).ParamCount = 1
    MyFuncs(3).ReturnType = TxNumber
    
    For i = 0 To MyFuncsCount - 1
        'Adds user defined funtions to the script language
        TLC.AddFunction MyFuncs(i).KeyWord, MyFuncs(i).ParamCount, MyFuncs(i).Ordinal, MyFuncs(i).ReturnType
    Next i
    
End Sub

Public Sub TLC_Date(TLC As TLang)

    Dim sDateFormat As String
    
    TLC.GetSParam 1, sDateFormat
    
    TLC.UserSReturn = Format(Now, sDateFormat)
    

End Sub

Public Sub TLC_Time(TLC As TLang)

    Dim sTimeFormat As String
    Dim s As String
    
    TLC.GetSParam 1, sTimeFormat
    
    TLC.UserSReturn = Format(Now, sTimeFormat)
    
End Sub

Public Sub TLC_GetSeconds(TLC As TLang)

    Dim sDate1 As String
    Dim sDate2 As String

    TLC.GetSParam 1, sDate1
    TLC.GetSParam 2, sDate2
    
    TLC.UserNReturn = Int(DateDiff("s", sDate1, sDate2))
    
End Sub

Public Sub TLC_Wait(TLC As TLang)

    Dim d As Date
    Dim Interval As Double

    TLC.GetNParam 1, Interval
    d = DateAdd("s", Interval, Now)

    While Now < d
        DoEvents
    Wend

End Sub


