///////////////////////////////////////////////////////////////////////////////
//
//  Function-oriented code created by the Xbase++ FormDesigner
//    Creation date: 05/15/00 Time: 04:49:27
//
///////////////////////////////////////////////////////////////////////////////
//
//  xpp winftp.prg
//  alink /subsystem:windows winftp.obj fce32.lib
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"

#INCLUDE "DLL.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "FCE32.CH"

PUBLIC oXbpClear
PUBLIC oXbpConnect
PUBLIC oXbpDel
PUBLIC oXbpExit
PUBLIC oXbpFullList
PUBLIC oXbpGet
PUBLIC oXbpLocalDir
PUBLIC oXbpNameList
PUBLIC oXbpOutput
PUBLIC oXbpPass
PUBLIC oXbpPassive
PUBLIC oXbpPut
PUBLIC oXbpServer
PUBLIC oXbpServerDir
PUBLIC oXbpSetAscii
PUBLIC oXbpSetBinary
PUBLIC oXbpSetLocal
PUBLIC oXbpSetServer
PUBLIC oXbpUser
PUBLIC oXbpFilename
PUBLIC oXbpStatus

#define TEMP_SIZE  128
#define DATA_SIZE 5000

return 0

Procedure DisplayText(Text)
X = oXbpOutput:getData()
oXbpOutput:setData(X + Text + Chr(13) + Chr(10) )
return

Procedure DisplayError(ErrCode)
Temp = SPACE(128)
Code = XfceErrorText(0,ErrCode,@Temp,128)
Temp = Left(Temp, Code)
Qout(Temp)
DisplayText(Temp)
return

Procedure SetPushTrue()
oXbpSetLocal:enable()
oXbpSetServer:enable()
oXbpNameList:enable()
oXbpFullList:enable()
oXbpSetAscii:enable()
oXbpSetBinary:enable()
oXbpPut:enable()
oXbpGet:enable()
oXbpDel:enable()
return

Procedure SetPushFalse()
oXbpSetLocal:disable()
oXbpSetServer:disable()
oXbpNameList:disable()
oXbpFullList:disable()
oXbpSetAscii:disable()
oXbpSetBinary:disable()
oXbpPut:disable()
oXbpGet:disable()
oXbpDel:disable()
return

Function Connect()
///oXbpConnect:caption := "Please wait"
///oXbpConnect:configure()
oXbpConnect:disable()
Server = oXbpServer:getData()
User = oXbpUser:getData()
Pass = oXbpPass:getData()
LocalDir = oXbpLocalDir:getData()
DiagFile = "WINFTP.LOG"
If FCE_KEY_CODE = 0
  DisplayText("*** Type 'SW Info' on tool bar at bottom of screen ! ***")
EndIf
// connect to FTP server
Code = XfceAttach(1, FCE_KEY_CODE)
if Code < 0
  DisplayText("Cannot attach FCE (check key code)")
  Qout("Cannot attach FCE")
  return 1
endif
// set LOG file name
Code = XfceSetString(0, FCE_SET_LOG_FILE, @DiagFile)
// connect to FTP server
DisplayText("Connecting to " + Server)
Code = XfceConnect(0, @Server, @User, @Pass)
if Code < 0
  DisplayError(Code)
  Code = XfceRelease()
  return 1
endif
// get server IP address
TempBuffer = SPACE(TEMP_SIZE)
Code = XfceGetString(0, FCE_GET_SERVER_IP, @TempBuffer, TEMP_SIZE)
if Code > 0
  DisplayText("Connected to " + Left(TempBuffer, Code))
endif
// get server directory
ServerDir = SPACE(TEMP_SIZE)
Code = XfceGetServerDir(0, @ServerDir)
oXbpServerDir:setData(ServerDir)
SetPushTrue()
return 0

Function SetLocal()
// set local directory
LocalDir = oXbpLocalDir:getData()
DisplayText("Setting local directory to " + LocalDir)
// append 0 to string before passing to FCE
LocalDir = LocalDir + Chr(0)
Code = XfceSetLocalDir(0, @LocalDir)
if Code < 0
   DisplayError(Code)
else
   // read local directory back
   LocalDir = SPACE(TEMP_SIZE)
   Code = XfceGetLocalDir(0, @LocalDir)
   if Code > 0
     LocalDir = Left(LocalDir, Code)
     oXbpLocalDir:setData(LocalDir)
     DisplayText("Local Directory is " + LocalDir)
   endif
endif
return 0

Function SetServer()
ServerDir = oXbpServerDir:getData()
DisplayText("Setting server directory to " + ServerDir)
// append 0 to string before passing to FCE
ServerDir = ServerDir + Chr(0)
Code = XfceSetServerDir(0, @ServerDir)
if Code < 0
   DisplayError(Code)
else
   // read server directory back
   ServerDir = SPACE(TEMP_SIZE)
   Code = XfceGetServerDir(0, @ServerDir)
   if Code > 0
     ServerDir = Left(ServerDir, Code)
     oXbpServerDir:setData(ServerDir)
     DisplayText("Server Directory is " + ServerDir)
   endif
endif
return 0

Function NameList()
// get file list by name
DataBuffer = SPACE(DATA_SIZE)
Code = XfceGetList(0, FCE_NAME_LIST, @DataBuffer, DATA_SIZE)
if Code <= 0
   DisplayError(Code)
else
   DisplayText(Left(DataBuffer,Code))
endif
return 0

Function FullList()
// get full file list
DataBuffer = SPACE(DATA_SIZE)
Code = XfceGetList(0, FCE_FULL_LIST, @DataBuffer, DATA_SIZE)
if Code <= 0
   DisplayError(Code)
else
   DisplayText(Left(DataBuffer,Code))
   Code = XfceGetString(0, FCE_GET_LINE_COUNT, @DataBuffer, DATA_SIZE)
   DisplayText(Str(Code) + " lines.")
endif
return 0

Function SetAscii()
Code = XfceSetMode(0, ASC("A"))
DisplayText("Xfer mode is ASCII")
return 0

Function SetBinary()
Code = XfceSetMode(0, ASC("B"))
DisplayText("Xfer mode is binary")
return 0

Function RunTheDriver
// run the driver
Counter = 0
LastCount = 0
ThisCount = 0
Code = 1
oXbpStatus:setData(" ")
SetPushFalse()
// call driver till it's done
do while Code > 0
  Code = XfceDriver(0)
  if Code < 0
    // error returned
    DisplayError(Code)
    SetPushTrue()
    return Code
  endif
  Counter = Counter + 1
  // check bytes transferred every 20'th call
  if ( (Counter == 20) .or. (Code == 0) )
    ThisCount = XfceGetInteger(0, FCE_GET_FILE_BYTES_SENT) + XfceGetInteger(0, FCE_GET_FILE_BYTES_RCVD)
    if ThisCount != LastCount
      oXbpStatus:setData(Str(ThisCount)+" bytes")
      LastCount = ThisCount
    endif
    Counter = 0
  endif
enddo
SetPushTrue()
return Code

Function GetFile()
// down file from server
FileName = oXbpFilename:getData()
if Asc(FileName) <> 0
  DisplayText("Please wait while file is being downloaded...")
  // turn AUTO CALL off
  Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
  Code = XfceGetFile(0, @FileName)
  if Code < 0
     DisplayError(Code)
  else
     // run the driver
     if RunTheDriver() == 0
       DisplayText(FileName + " downloaded.")
     endif
  endif
  // turn AUTO CALL back on
  Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
endif
return 0

Function PutFile()
// upload file to server
FileName = oXbpFilename:getData()
if Asc(FileName) <> 0
  DisplayText("Please wait while file is being uploaded...")
   // turn AUTO CALL off
  Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 0)
  Code = XfcePutFile(0, @FileName)
  if Code < 0
     DisplayError(Code)
  else
     // run the driver
     if RunTheDriver() == 0
       DisplayText(FileName + " uploaded.")
     endif
  endif
  // turn AUTO CALL back on
  Code = XfceSetInteger(0, FCE_SET_AUTO_CALL_DRIVER, 1)
endif
return 0

Function DelFile()
// delete file on server
FileName = oXbpFilename:getData()
if Asc(FileName) <> 0
  Code = XfceDelFile(0, @FileName)
  if Code < 0
     DisplayError(Code)
  else
     DisplayText(FileName + " deleted.")
  endif
endif
return 0


Function Passive()
if oXbpPassive:getData()
  // turn passive mode ON
  Code = XfceSetInteger(0, FCE_SET_PASSIVE, 1)
  DisplayText("Passive mode is ON")
else
  // turn passive mode OFF
  Code = XfceSetInteger(0, FCE_SET_PASSIVE, 0)
  DisplayText("Passive mode is OFF")
endif
return 0

Function Clear()
// clear display
oXbpOutput:setData("")
return 0

PROCEDURE Main
   LOCAL nEvent, mp1, mp2
   LOCAL oDlg, oXbp, drawingArea, aEditControls := {}
   LOCAL Code

   oDlg := XbpDialog():new( AppDesktop(), , {189,159}, {688,427}, , .F.)
   oDlg:taskList := .T.
   oDlg:title := "WinFTP"
   oDlg:create()

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( "8.Arial" )

   oXbpOutput := XbpMle():new( drawingArea, , {312,0}, {360,360}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpOutput:clipSiblings := .T.
   oXbpOutput:create()

   oXbp := XbpStatic():new( drawingArea, , {0,372}, {108,24}, { { XBP_PP_COMPOUNDNAME, "12.MS Sans Serif" } } )
   oXbp:caption := "FTP Server"
   oXbp:clipSiblings := .T.
   oXbp:create()

   oXbpServer := XbpSLE():new( drawingArea, , {96,348}, {108,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpServer:clipSiblings := .T.
   oXbpServer:create()

   oXbpUser := XbpSLE():new( drawingArea, , {96,324}, {108,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpUser:clipSiblings := .T.
   oXbpUser:create()

   oXbpPass := XbpSLE():new( drawingArea, , {96,300}, {108,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpPass:clipSiblings := .T.
   oXbpPass:create()

   oXbp := XbpStatic():new( drawingArea, , {0,348}, {84,24} )
   oXbp:caption := "Name"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,324}, {84,24} )
   oXbp:caption := "User"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,300}, {84,24} )
   oXbp:caption := "Password"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,264}, {108,24}, { { XBP_PP_COMPOUNDNAME, "12.MS Sans Serif" } } )
   oXbp:caption := "Local Directory"
   oXbp:clipSiblings := .T.
   oXbp:create()

   oXbpLocalDir := XbpSLE():new( drawingArea, , {96,228}, {108,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpLocalDir:clipSiblings := .T.
   oXbpLocalDir:create()

   oXbp := XbpStatic():new( drawingArea, , {0,228}, {84,24} )
   oXbp:caption := "Dir Name"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,192}, {132,24}, { { XBP_PP_COMPOUNDNAME, "12.MS Sans Serif" } } )
   oXbp:caption := "Server Directory"
   oXbp:clipSiblings := .T.
   oXbp:create()

   oXbpServerDir := XbpSLE():new( drawingArea, , {96,156}, {108,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpServerDir:clipSiblings := .T.
   oXbpServerDir:create()

   oXbp := XbpStatic():new( drawingArea, , {0,156}, {84,24} )
   oXbp:caption := "Dir Name"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbpConnect := XbpPushButton():new( drawingArea, , {216,324}, {84,24} )
   oXbpConnect:caption := "Connect"
   oXbpConnect:clipSiblings := .T.
   oXbpConnect:create()
   oXbpConnect:activate  := {|| Code = Connect()}

   oXbpExit := XbpPushButton():new( drawingArea, , {216,300}, {84,24} )
   oXbpExit:caption := "Exit"
   oXbpExit:clipSiblings := .T.
   oXbpExit:create()
   oXbpExit:activate := {|| Code = XfceClose(0), Code = XfceRelease(), Gather( aEditControls ), PostAppEvent( xbeP_Close ) }

   oXbpSetLocal := XbpPushButton():new( drawingArea, , {216,228}, {84,24} )
   oXbpSetLocal:caption := "Set"
   oXbpSetLocal:clipSiblings := .T.
   oXbpSetLocal:create()
   oXbpSetLocal:activate := {|| Code = SetLocal() }

   oXbpSetServer := XbpPushButton():new( drawingArea, , {216,156}, {84,24} )
   oXbpSetServer:caption := "Set"
   oXbpSetServer:clipSiblings := .T.
   oXbpSetServer:create()
   oXbpSetServer:activate := {|| Code = SetServer() }

   oXbp := XbpStatic():new( drawingArea, , {0,120}, {84,24} )
   oXbp:caption := "List Files"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbpNameList := XbpPushButton():new( drawingArea, , {96,120}, {60,24} )
   oXbpNameList:caption := "Name"
   oXbpNameList:clipSiblings := .T.
   oXbpNameList:create()
   oXbpNameList:activate := {|| Code = NameList() }

   oXbpFullList := XbpPushButton():new( drawingArea, , {156,120}, {60,24} )
   oXbpFullList:caption := "Full"
   oXbpFullList:clipSiblings := .T.
   oXbpFullList:create()
   oXbpFullList:activate := {|| Code = FullList() }

   oXbp := XbpStatic():new( drawingArea, , {0,84}, {84,24}, { { XBP_PP_COMPOUNDNAME, "12.MS Sans Serif" } } )
   oXbp:caption := "File Xfer"
   oXbp:clipSiblings := .T.
   oXbp:create()

   oXbpSetAscii := XbpRadiobutton():new( drawingArea, , {96,84}, {96,24} )
   oXbpSetAscii:caption := "ASCII"
   oXbpSetAscii:clipSiblings := .T.
   oXbpSetAscii:selection := .T.
   oXbpSetAscii:create()
   oXbpSetAscii:selected := {|| Code = SetAscii() }

   oXbpSetBinary := XbpRadiobutton():new( drawingArea, , {180,84}, {84,24} )
   oXbpSetBinary:caption := "Binary"
   oXbpSetBinary:clipSiblings := .T.
   oXbpSetBinary:create()
   oXbpSetBinary:selected := {|| Code = SetBinary() }

   oXbp := XbpStatic():new( drawingArea, , {372,396}, {84,24} )
   oXbp:caption := "Text"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,60}, {84,24} )
   oXbp:caption := "Filename"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbp := XbpStatic():new( drawingArea, , {0,24}, {84,24} )
   oXbp:caption := "Action"
   oXbp:clipSiblings := .T.
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oXbpFilename := XbpSLE():new( drawingArea, , {96,60}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpFilename:clipSiblings := .T.
   oXbpFilename:create()

   oXbpGet := XbpPushButton():new( drawingArea, , {96,24}, {48,24} )
   oXbpGet:caption := "Get"
   oXbpGet:clipSiblings := .T.
   oXbpGet:create()
   oXbpGet:activate := {|| Code = GetFile()  }

   oXbpPut := XbpPushButton():new( drawingArea, , {144,24}, {48,24} )
   oXbpPut:caption := "Put"
   oXbpPut:clipSiblings := .T.
   oXbpPut:create()
   oXbpPut:activate := {|| Code = PutFile()  }

   oXbpDel := XbpPushButton():new( drawingArea, , {192,24}, {48,24} )
   oXbpDel:caption := "Del"
   oXbpDel:clipSiblings := .T.
   oXbpDel:create()
   oXbpDel:activate := {|| Code = DelFile()  }

   oXbpPassive := XbpCheckbox():new( drawingArea, , {228,120}, {72,24} )
   oXbpPassive:caption := "Passive"
   oXbpPassive:clipSiblings := .T.
   oXbpPassive:create()
   oXbpPassive:selected := {|| Code = Passive() }
   ///oXbpPassive:selection := .T.

   oXbpClear := XbpPushButton():new( drawingArea, , {456,372}, {96,24} )
   oXbpClear :caption := "Clear"
   oXbpClear :clipSiblings := .T.
   oXbpClear :create()
   oXbpClear :activate := {|| Code = Clear() }

   oXbpStatus := XbpSLE():new( drawingArea, , {312,372}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbpStatus:clipSiblings := .T.
   oXbpStatus:create()

   // set server parameters
   oXbpServer:setData("10.0.0.1")
   oXbpUser:setData("mike")
   oXbpPass:setData("mike")

   SetPushFalse()

   oDlg:show()

   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN